(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('c3')) :
  typeof define === 'function' && define.amd ? define('vue-patternfly', ['exports', 'c3'], factory) :
  (factory((global.VuePatternfly = global.VuePatternfly || {}),global.c3));
}(this, (function (exports,c3) { 'use strict';

c3 = 'default' in c3 ? c3['default'] : c3;

var AggregateStatusCard = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "card-pf card-pf-aggregate-status", class: {
        'card-pf-accented': _vm.accented,
        'card-pf-aggregate-status-alt': _vm.isLayoutTall,
        'card-pf-aggregate-status-mini': _vm.isLayoutMini
      } }, [_c('h2', { staticClass: "card-pf-title" }, [_c(_vm.href ? 'a' : 'span', { tag: "span", attrs: { "href": _vm.href } }, [_vm.iconClass ? _c('span', { class: _vm.iconClass }) : _vm._e(), _vm._v(" "), _vm.count ? _c('span', { staticClass: "card-pf-aggregate-status-count" }, [_vm._v(_vm._s(_vm.count))]) : _vm._e(), _vm._v(" "), _c('span', { staticClass: "card-pf-aggregate-status-title" }, [_vm._v(_vm._s(_vm.title))])])]), _vm._v(" "), _c('div', { staticClass: "card-pf-body" }, [_c('p', { directives: [{ name: "show", rawName: "v-show", value: !_vm.isLayoutMini || _vm.iconClass || _vm.count, expression: "!isLayoutMini || iconClass || count" }], staticClass: "card-pf-aggregate-status-notifications" }, [_vm._t("default")], 2)])]);
  },
  staticRenderFns: [],
  name: 'pf-aggregate-status-card',

  props: {
    title: String,
    count: [String, Number],
    href: String,
    iconClass: String,
    layout: String,
    accented: {
      type: Boolean,
      default: true
    }
  },

  computed: {
    isLayoutTall: function isLayoutTall() {
      return this.layout === 'tall';
    },
    isLayoutMini: function isLayoutMini() {
      return this.layout === 'mini';
    }
  }
};

var C3Chart = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div');
  },
  staticRenderFns: [],
  name: 'pf-c3-chart',

  props: {
    type: {
      type: String,
      default: 'bar'
    },
    title: String,
    width: Number,
    height: Number,
    data: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    axis: {
      type: Object,
      default: function _default() {
        return {};
      }
    }
  },

  mounted: function mounted() {
    var chartData = {
      bindto: this.$el,
      size: {
        width: this.width,
        height: this.height
      },
      data: Object.assign({}, this.data)
    };
    chartData[this.type] = {};

    chartData.data.type = this.type;

    if (this.title) {
      chartData[this.type].title = this.title;
    }

    this.chart = c3.generate(chartData);
  }
};

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};











var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();







var get$1 = function get$1(object, property, receiver) {
  if (object === null) object = Function.prototype;
  var desc = Object.getOwnPropertyDescriptor(object, property);

  if (desc === undefined) {
    var parent = Object.getPrototypeOf(object);

    if (parent === null) {
      return undefined;
    } else {
      return get$1(parent, property, receiver);
    }
  } else if ("value" in desc) {
    return desc.value;
  } else {
    var getter = desc.get;

    if (getter === undefined) {
      return undefined;
    }

    return getter.call(receiver);
  }
};

















var set$1 = function set$1(object, property, value, receiver) {
  var desc = Object.getOwnPropertyDescriptor(object, property);

  if (desc === undefined) {
    var parent = Object.getPrototypeOf(object);

    if (parent !== null) {
      set$1(parent, property, value, receiver);
    }
  } else if ("value" in desc && desc.writable) {
    desc.value = value;
  } else {
    var setter = desc.set;

    if (setter !== undefined) {
      setter.call(receiver, value);
    }
  }

  return value;
};

var ArrayProto = Array.prototype;
var nodeError = new Error('Passed arguments must be of Node');
var blurEvent = void 0;
var blurList = [];
var Events = [];

function isNode(val) {
  return val instanceof window.Node;
}
function isNodeList(val) {
  return val instanceof window.NodeList || val instanceof NodeList || val instanceof window.HTMLCollection || val instanceof Array;
}

var NodeList = function () {
  function NodeList(args) {
    classCallCheck(this, NodeList);

    var nodes = args;
    if (args[0] === window) {
      nodes = [window];
    } else if (typeof args[0] === 'string') {
      nodes = (args[1] || document).querySelectorAll(args[0]);
      if (args[1]) {
        this.owner = args[1];
      }
    } else if (0 in args && !isNode(args[0]) && args[0] && 'length' in args[0]) {
      nodes = args[0];
      if (args[1]) {
        this.owner = args[1];
      }
    }
    if (nodes) {
      for (var i in nodes) {
        this[i] = nodes[i];
      }
      this.length = nodes.length;
    } else {
      this.length = 0;
    }
  }

  createClass(NodeList, [{
    key: 'concat',
    value: function concat() {
      var nodes = ArrayProto.slice.call(this);
      function flatten(arr) {
        ArrayProto.forEach.call(arr, function (el) {
          if (isNode(el)) {
            if (!~nodes.indexOf(el)) nodes.push(el);
          } else if (isNodeList(el)) {
            flatten(el);
          }
        });
      }

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      ArrayProto.forEach.call(args, function (arg) {
        if (isNode(arg)) {
          if (!~nodes.indexOf(arg)) nodes.push(arg);
        } else if (isNodeList(arg)) {
          flatten(arg);
        } else {
          throw Error('Concat arguments must be of a Node, NodeList, HTMLCollection, or Array of (Node, NodeList, HTMLCollection, Array)');
        }
      });
      return NodeListJS(nodes, this);
    }
  }, {
    key: 'delete',
    value: function _delete() {
      var notRemoved = flatten(this).filter(function (el) {
        if (el.remove) {
          el.remove();
        } else if (el.parentNode) {
          el.parentNode.removeChild(el);
        }
        return document.body.contains(el);
      });
      if (notRemoved.length) console.warn('NodeList: Some nodes could not be deleted.');
      return notRemoved;
    }
  }, {
    key: 'each',
    value: function each() {
      ArrayProto.forEach.apply(this, arguments);
      return this;
    }
  }, {
    key: 'filter',
    value: function filter() {
      return NodeListJS(ArrayProto.filter.apply(this, arguments), this);
    }
  }, {
    key: 'find',
    value: function find(element) {
      var nodes = [];
      flatten(this).forEach(function (node) {
        ArrayProto.push.apply(nodes, node.querySelectorAll(element));
      });
      return flatten(nodes, this.owner);
    }
  }, {
    key: 'findChildren',
    value: function findChildren(element) {
      var _this = this;

      if (element) return this.find(element).filter(function (el) {
        return _this.includes(el.parentElement);
      });
      return flatten(this.map(function (el) {
        return el.children;
      }));
    }
  }, {
    key: 'forEach',
    value: function forEach() {
      ArrayProto.forEach.apply(this, arguments);
      return this;
    }
  }, {
    key: 'includes',
    value: function includes(element, index) {
      return ~this.indexOf(element, index);
    }
  }, {
    key: 'map',
    value: function map() {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      var mapped = ArrayProto.map.apply(this, args);
      return mapped.some(function (el) {
        return isNode(el) || isNodeList(el);
      }) ? flatten(mapped, this) : mapped;
    }
  }, {
    key: 'parent',
    value: function parent() {
      return flatten(this.map(function (el) {
        return el.parentNode;
      }), this);
    }
  }, {
    key: 'pop',
    value: function pop(amount) {
      if (typeof amount !== 'number') {
        amount = 1;
      }
      var nodes = [];
      var pop = ArrayProto.pop.bind(this);
      while (amount--) {
        nodes.push(pop());
      }return NodeListJS(nodes, this);
    }
  }, {
    key: 'push',
    value: function push() {
      var _this2 = this;

      for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      ArrayProto.forEach.call(args, function (arg) {
        if (!isNode(arg)) throw nodeError;
        if (!~_this2.indexOf(arg)) ArrayProto.push.call(_this2, arg);
      });
      return this;
    }
  }, {
    key: 'shift',
    value: function shift(amount) {
      if (typeof amount !== 'number') {
        amount = 1;
      }
      var nodes = [];
      while (amount--) {
        nodes.push(ArrayProto.shift.call(this));
      }return nodes.length == 1 ? nodes[0] : NodeListJS(nodes, this);
    }
  }, {
    key: 'slice',
    value: function slice() {
      for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args[_key4] = arguments[_key4];
      }

      return NodeListJS(ArrayProto.slice.apply(this, args), this);
    }
  }, {
    key: 'splice',
    value: function splice() {
      for (var _len5 = arguments.length, args = Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
        args[_key5] = arguments[_key5];
      }

      for (var i = 2, l = args.length; i < l; i++) {
        if (!isNode(args[i])) throw nodeError;
      }
      ArrayProto.splice.apply(this, args);
      return this;
    }
  }, {
    key: 'unshift',
    value: function unshift() {
      var _this3 = this;

      var unshift = ArrayProto.unshift.bind(this);

      for (var _len6 = arguments.length, args = Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
        args[_key6] = arguments[_key6];
      }

      ArrayProto.forEach.call(args, function (arg) {
        if (!isNode(arg)) throw nodeError;
        if (!~_this3.indexOf(arg)) unshift(arg);
      });
      return this;
    }
  }, {
    key: 'addClass',
    value: function addClass(classes) {
      return this.toggleClass(classes, true);
    }
  }, {
    key: 'removeClass',
    value: function removeClass(classes) {
      return this.toggleClass(classes, false);
    }
  }, {
    key: 'toggleClass',
    value: function toggleClass(classes, value) {
      var _this4 = this;

      var method = value === undefined || value === null ? 'toggle' : value ? 'add' : 'remove';
      if (typeof classes === 'string') {
        classes = classes.trim().replace(/\s+/, ' ').split(' ');
      }
      classes.forEach(function (c) {
        return _this4.each(function (el) {
          return el.classList[method](c);
        });
      });
      return this;
    }
  }, {
    key: 'get',
    value: function get(prop) {
      var arr = [];
      this.each(function (el) {
        if (el !== null) {
          el = el[prop];
        }
        arr.push(el);
      });
      return flatten(arr, this);
    }
  }, {
    key: 'set',
    value: function set(prop, value) {
      if (prop.constructor === Object) {
        this.each(function (el) {
          if (el) {
            for (var key in prop) {
              if (key in el) {
                el[key] = prop[key];
              }
            }
          }
        });
      } else {
        this.each(function (el) {
          if (prop in el) {
            el[prop] = value;
          }
        });
      }
      return this;
    }
  }, {
    key: 'call',
    value: function call() {
      for (var _len7 = arguments.length, args = Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
        args[_key7] = arguments[_key7];
      }

      var method = ArrayProto.shift.call(args);
      var arr = [];
      var returnThis = true;
      this.each(function (el) {
        if (el && el[method] instanceof Function) {
          el = el[method].apply(el, args);
          arr.push(el);
          if (returnThis && el !== undefined) {
            returnThis = false;
          }
        } else {
          arr.push(undefined);
        }
      });
      return returnThis ? this : flatten(arr, this);
    }
  }, {
    key: 'item',
    value: function item(index) {
      return NodeListJS([this[index]], this);
    }
  }, {
    key: 'on',


    // event handlers
    value: function on(events, selector, callback) {
      if (typeof events === 'string') {
        events = events.trim().replace(/\s+/, ' ').split(' ');
      }
      if (!this || !this.length) return this;
      if (callback === undefined) {
        callback = selector;
        selector = null;
      }
      if (!callback) return this;
      var fn = callback;
      callback = selector ? function (e) {
        var els = NodeListJS(selector, this);
        if (!els.length) {
          return;
        }
        els.some(function (el) {
          var target = el.contains(e.target);
          if (target) fn.call(el, e, el);
          return target;
        });
      } : function (e) {
        fn.apply(this, [e, this]);
      };
      this.each(function (el) {
        events.forEach(function (event) {
          if (el === window || isNode(el)) {
            el.addEventListener(event, callback, false);
            Events.push({
              el: el,
              event: event,
              callback: callback
            });
          }
        });
      });
      return this;
    }
  }, {
    key: 'off',
    value: function off(events, callback) {
      if (events instanceof Function) {
        callback = events;
        events = null;
      }
      if (typeof events === 'string' && callback instanceof Function) {
        this.each(function (el) {
          events.split(' ').forEach(function (event) {
            Events.forEach(function (e) {
              if (Events[e] && Events[e].el === el && Events[e].event === event && Events[e].callback === callback) {
                Events[e].el.removeEventListener(Events[e].event, Events[e].callback);
                delete Events[e];
              }
            });
          });
        });
      } else if (typeof events === 'string') {
        this.each(function (el) {
          events.split(' ').forEach(function (event) {
            Events.forEach(function (e) {
              if (Events[e] && Events[e].el === el && Events[e].event === event) {
                Events[e].el.removeEventListener(Events[e].event, Events[e].callback);
                delete Events[e];
              }
            });
          });
        });
      } else if (callback instanceof Function) {
        this.each(function (el) {
          Events.forEach(function (e) {
            if (Events[e] && Events[e].el === el && Events[e].callback === callback) {
              Events[e].el.removeEventListener(Events[e].event, Events[e].callback);
              delete Events[e];
            }
          });
        });
      } else {
        this.each(function (el) {
          Events.forEach(function (e) {
            if (Events[e] && Events[e].el === el) {
              Events[e].el.removeEventListener(Events[e].event, Events[e].callback);
              delete Events[e];
            }
          });
        });
      }
      Events = Events.filter(function (el) {
        return el !== undefined;
      });
      return this;
    }
  }, {
    key: 'onBlur',
    value: function onBlur(callback) {
      if (!this || !this.length) return this;
      if (!callback) return this;
      this.each(function (el) {
        blurList.push({ el: el, callback: callback });
      });
      if (!blurEvent) {
        blurEvent = function blurEvent(e) {
          blurList.forEach(function (item) {
            var target = item.el.contains(e.target) || item.el === e.target;
            if (!target) item.callback.call(item.el, e, item.el);
          });
        };
        document.addEventListener('click', blurEvent, false);
        document.addEventListener('touchstart', blurEvent, false);
      }
      return this;
    }
  }, {
    key: 'offBlur',
    value: function offBlur(callback) {
      this.each(function (el) {
        blurList = blurList.filter(function (blur) {
          if (blur && blur.el === el && (!callback || blur.callback === callback)) {
            return false;
          }
          return el;
        });
      });
      return this;
    }
  }, {
    key: 'asArray',
    get: function get() {
      return ArrayProto.slice.call(this);
    }
  }]);
  return NodeList;
}();

var NL = NodeList.prototype;

function flatten(arr, owner) {
  var list = [];
  ArrayProto.forEach.call(arr, function (el) {
    if (isNode(el)) {
      if (!~list.indexOf(el)) list.push(el);
    } else if (isNodeList(el)) {
      for (var id in el) {
        list.push(el[id]);
      }
    } else if (el !== null) {
      arr.get = NL.get;
      arr.set = NL.set;
      arr.call = NL.call;
      arr.owner = owner;
      return arr;
    }
  });
  return NodeListJS(list, owner);
}

Object.getOwnPropertyNames(ArrayProto).forEach(function (key) {
  if (key !== 'join' && key !== 'copyWithin' && key !== 'fill' && NL[key] === undefined) {
    NL[key] = ArrayProto[key];
  }
});
if (window.Symbol && Symbol.iterator) {
  NL[Symbol.iterator] = NL.values = ArrayProto[Symbol.iterator];
}
var div = document.createElement('div');
function setterGetter(prop) {
  var _this5 = this;

  if (NL[prop]) return;
  if (div[prop] instanceof Function) {
    NL[prop] = function () {
      for (var _len8 = arguments.length, args = Array(_len8), _key8 = 0; _key8 < _len8; _key8++) {
        args[_key8] = arguments[_key8];
      }

      var arr = [];
      var returnThis = true;
      for (var i in NL) {
        var el = NL[i];
        if (el && el[prop] instanceof Function) {
          el = el[prop].apply(el, args);
          arr.push(el);
          if (returnThis && el !== undefined) {
            returnThis = false;
          }
        } else {
          arr.push(undefined);
        }
      }
      return returnThis ? _this5 : flatten(arr, _this5);
    };
  } else {
    Object.defineProperty(NL, prop, {
      get: function get() {
        var arr = [];
        this.each(function (el) {
          if (el !== null) {
            el = el[prop];
          }
          arr.push(el);
        });
        return flatten(arr, this);
      },
      set: function set(value) {
        this.each(function (el) {
          if (el && prop in el) {
            el[prop] = value;
          }
        });
      }
    });
  }
}
for (var prop in div) {
  setterGetter(prop);
}function NodeListJS() {
  for (var _len9 = arguments.length, args = Array(_len9), _key9 = 0; _key9 < _len9; _key9++) {
    args[_key9] = arguments[_key9];
  }

  return new NodeList(args);
}
window.NL = NodeListJS;

// coerce convert som types of data into another type
var coerce = {
  // Convert a string to booleam. Otherwise, return the value without modification, so if is not boolean, Vue throw a warning.
  boolean: function boolean(val) {
    return typeof val === 'string' ? val === '' || val === 'true' ? true : val === 'false' || val === 'null' || val === 'undefined' ? false : val : val;
  },
  // Attempt to convert a string value to a Number. Otherwise, return 0.
  number: function number(val) {
    var alt = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    return typeof val === 'number' ? val : val === undefined || val === null || isNaN(Number(val)) ? alt : Number(val);
  },
  // Attempt to convert to string any value, except for null or undefined.
  string: function string(val) {
    return val === undefined || val === null ? '' : val + '';
  },
  // Pattern accept RegExp, function, or string (converted to RegExp). Otherwise return null.
  pattern: function pattern(val) {
    return val instanceof Function || val instanceof RegExp ? val : typeof val === 'string' ? new RegExp(val) : null;
  }
};

function getJSON(url) {
  var request = new window.XMLHttpRequest();
  var data = {};
  // p (-simulated- promise)
  var p = {
    then: function then(fn1, fn2) {
      return p.done(fn1).fail(fn2);
    },
    catch: function _catch(fn) {
      return p.fail(fn);
    },
    always: function always(fn) {
      return p.done(fn).fail(fn);
    }
  };
  ['done', 'fail'].forEach(function (name) {
    data[name] = [];
    p[name] = function (fn) {
      if (fn instanceof Function) data[name].push(fn);
      return p;
    };
  });
  p.done(JSON.parse);
  request.onreadystatechange = function () {
    if (request.readyState === 4) {
      var response;
      var i;
      var value;

      (function () {
        var e = { status: request.status };
        if (request.status === 200) {
          try {
            response = request.responseText;

            for (i in data.done) {
              value = data.done[i](response);

              if (value !== undefined) {
                response = value;
              }
            }
          } catch (err) {
            data.fail.forEach(function (fail) {
              return fail(err);
            });
          }
        } else {
          data.fail.forEach(function (fail) {
            return fail(e);
          });
        }
      })();
    }
  };
  request.open('GET', url);
  request.setRequestHeader('Accept', 'application/json');
  request.send();
  return p;
}

function getScrollBarWidth() {
  if (document.documentElement.scrollHeight <= document.documentElement.clientHeight) {
    return 0;
  }
  var inner = document.createElement('p');
  inner.style.width = '100%';
  inner.style.height = '200px';

  var outer = document.createElement('div');
  outer.style.position = 'absolute';
  outer.style.top = '0px';
  outer.style.left = '0px';
  outer.style.visibility = 'hidden';
  outer.style.width = '200px';
  outer.style.height = '150px';
  outer.style.overflow = 'hidden';
  outer.appendChild(inner);

  document.body.appendChild(outer);
  var w1 = inner.offsetWidth;
  outer.style.overflow = 'scroll';
  var w2 = inner.offsetWidth;
  if (w1 === w2) w2 = outer.clientWidth;

  document.body.removeChild(outer);

  return w1 - w2;
}

// return all the translations or the default language (english)
function translations() {
  var lang = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'en';

  var text = {
    daysOfWeek: ['Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa'],
    limit: 'Limit reached ({{limit}} items max).',
    loading: 'Loading...',
    minLength: 'Min. Length',
    months: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],
    notSelected: 'Nothing Selected',
    required: 'Required',
    search: 'Search'
  };
  return window.VueStrapLang ? window.VueStrapLang(lang) : text;
}

// delayer: set a function that execute after a delay
// @params (function, delay_prop or value, default_value)
function delayer(fn, varTimer) {
  var ifNaN = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 100;

  function toInt(el) {
    return (/^[0-9]+$/.test(el) ? Number(el) || 1 : null
    );
  }
  var timerId;
  return function () {
    var _this = this;

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    if (timerId) clearTimeout(timerId);
    timerId = setTimeout(function () {
      fn.apply(_this, args);
    }, toInt(varTimer) || toInt(this[varTimer]) || ifNaN);
  };
}

// Fix a vue instance Lifecycle to vue 1/2 (just the basic elements, is not a real parser, so this work only if your code is compatible with both)
// (Waiting for testing)

/**
 * Click outside directive
 */
var binded = [];

function handler$1(e) {
  binded.forEach(function (el) {
    if (!el.node.contains(e.target)) el.callback(e);
  });
}

function addListener(node, callback) {
  if (!binded.length) document.addEventListener('click', handler$1, false);
  binded.push({ node: node, callback: callback });
}

function removeListener(node, callback) {
  binded = binded.filter(function (el) {
    return el.node !== node ? true : !callback ? false : el.node.callback !== callback;
  });
  if (!binded.length) document.removeEventListener('click', handler$1, false);
}

var ClickOutside = {
  bind: function bind(el, binding) {
    removeListener(el, binding.value);
    if (typeof binding.value !== 'function') {
      if (process.env.NODE_ENV !== 'production') {
        Vue.util.warn('ClickOutside only work with a function, received: v-' + binding.name + '="' + binding.expression + '"');
      }
    } else {
      addListener(el, binding.value);
    }
  },
  update: function update(el, binding) {
    if (binding.value !== binding.oldValue) {
      removeListener(el, binding.oldValue);
      addListener(el, binding.value);
    }
  },
  unbind: function unbind(el, binding) {
    removeEventListener(el, binding.value);
  }
};

/**
 * Click outside directive
 */
var HANDLER = '_vue_scroll_handler';
var events = ['resize', 'scroll'];

function bind$1(el, binding) {
  unbind$1(el);

  var callback = binding.value;
  if (typeof callback !== 'function') {
    if (process.env.NODE_ENV !== 'production') {
      Vue.util.warn('ClickOutside only work with a function value, received: v-' + binding.name + '="' + binding.expression + '"');
    }
  } else {
    el[HANDLER] = function (e) {
      callback(e);
    };
    events.forEach(function (e) {
      window.addEventListener(e, el[HANDLER], false);
    });
    document.addEventListener('load', el[HANDLER], false);
    setTimeout(function () {
      el[HANDLER]();
    }, 0);
  }
}

function unbind$1(el) {
  events.forEach(function (e) {
    window.removeEventListener(e, el[HANDLER], false);
  });
  document.removeEventListener('load', el[HANDLER], false);
  delete el[HANDLER];
}

var Scroll = {
  bind: bind$1,
  unbind: unbind$1,
  update: function update(el, binding) {
    if (binding.value !== binding.oldValue) bind$1(el, binding);
  }
};

// let coerce = {
//   oneAtAtime: 'boolean'
// }

var accordion = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "panel-group" }, [_vm._t("default")], 2);
  },
  staticRenderFns: [],
  props: {
    type: {
      type: String,
      default: null
    },
    oneAtAtime: {
      type: Boolean,
      default: false
    }
  },
  created: function created() {
    var _this = this;

    this._isAccordion = true;
    this.$on('isOpenEvent', function (child) {
      if (_this.oneAtAtime) {
        _this.$children.forEach(function (item) {
          if (child !== item) {
            item.isOpen = false;
          }
        });
      }
    });
  }
};

var affix = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "hidden-print hidden-xs hidden-sm" }, [_c('nav', { directives: [{ name: "scroll", rawName: "v-scroll", value: _vm.checkScroll, expression: "checkScroll" }], staticClass: "bs-docs-sidebar", class: { affix: _vm.affixed }, style: { marginTop: _vm.top } }, [_vm._t("default")], 2)]);
  },
  staticRenderFns: [],
  directives: {
    Scroll: Scroll
  },
  props: {
    offset: {
      type: Number,
      default: 0
    }
  },
  data: function data() {
    return {
      affixed: false
    };
  },

  computed: {
    top: function top() {
      return this.offset > 0 ? this.offset + 'px' : null;
    }
  },
  methods: {
    // from https://github.com/ant-design/ant-design/blob/master/components/affix/index.jsx#L20
    checkScroll: function checkScroll() {
      // if is hidden don't calculate anything
      if (!(this.$el.offsetWidth || this.$el.offsetHeight || this.$el.getClientRects().length)) {
        return;
      }
      // get window scroll and element position to detect if have to be normal or affixed
      var scroll = {};
      var element = {};
      var rect = this.$el.getBoundingClientRect();
      var body = document.body;
      var _arr = ['Top', 'Left'];
      for (var _i = 0; _i < _arr.length; _i++) {
        var type = _arr[_i];
        var t = type.toLowerCase();
        var ret = window['page' + (type === 'Top' ? 'Y' : 'X') + 'Offset'];
        var method = 'scroll' + type;
        if (typeof ret !== 'number') {
          // ie6,7,8 standard mode
          ret = document.documentElement[method];
          if (typeof ret !== 'number') {
            // quirks mode
            ret = document.body[method];
          }
        }
        scroll[t] = ret;
        element[t] = scroll[t] + rect[t] - (this.$el['client' + type] || body['client' + type] || 0);
      }
      var fix = scroll.top > element.top - this.offset;
      if (this.affixed !== fix) {
        this.affixed = fix;
      }
    }
  }
};

var DURATION = 0;
var alert = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('transition', { attrs: { "name": "fade" } }, [_c('div', { directives: [{ name: "show", rawName: "v-show", value: _vm.val, expression: "val" }], class: ['alert', 'alert-' + _vm.type, _vm.placement], style: { width: _vm.width }, attrs: { "role": "alert" } }, [_c('button', { directives: [{ name: "show", rawName: "v-show", value: _vm.dismissable, expression: "dismissable" }], staticClass: "close", attrs: { "type": "button" }, on: { "click": function click($event) {
          _vm.val = false;
        } } }, [_c('span', [_vm._v("×")])]), _vm._v(" "), _vm._t("default")], 2)]);
  },
  staticRenderFns: [],
  props: {
    dismissable: { type: Boolean, default: false },
    duration: { default: DURATION },
    placement: { type: String },
    type: { type: String },
    value: { type: Boolean, default: true },
    width: { type: String }
  },
  data: function data() {
    return {
      val: this.value
    };
  },

  computed: {
    durationNum: function durationNum() {
      return coerce.number(this.duration, DURATION);
    }
  },
  watch: {
    val: function val(_val) {
      if (_val && this.durationNum > 0) {
        this._delayClose();
      }
      this.$emit('input', _val);
    },
    value: function value(val) {
      if (this.val !== val) {
        this.val = val;
      }
    }
  },
  created: function created() {
    this._delayClose = delayer(function () {
      this.val = false;
    }, 'durationNum');
  }
};

// let coerce = {
//   value: 'boolean',
//   width: 'number'
// }

var aside = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('transition', { attrs: { "name": 'side' + this.placement } }, [_vm.show ? _c('div', { staticClass: "aside", class: _vm.placement, style: { width: _vm.width + 'px' } }, [_c('div', { staticClass: "aside-dialog" }, [_c('div', { staticClass: "aside-content" }, [_c('div', { staticClass: "aside-header" }, [_c('button', { staticClass: "close", attrs: { "type": "button" }, on: { "click": _vm.trigger_close } }, [_c('span', [_vm._v("×")])]), _vm._v(" "), _c('h4', { staticClass: "aside-title" }, [_vm._t("header", [_vm._v(_vm._s(_vm.header))])], 2)]), _vm._v(" "), _c('div', { staticClass: "aside-body" }, [_vm._t("default")], 2)])])]) : _vm._e()]);
  },
  staticRenderFns: [],
  props: {
    header: { type: String },
    placement: { type: String, default: 'right' },
    show: { type: Boolean, required: true },
    width: { type: Number, default: 320 }
  },
  watch: {
    show: function show(val, old) {
      var _this = this;

      this.$emit('input', val);
      this.$emit(this.show ? 'open' : 'close');
      var body = document.body;
      var scrollBarWidth = getScrollBarWidth();
      if (val) {
        if (!this._backdrop) {
          this._backdrop = document.createElement('div');
        }
        this._backdrop.className = 'aside-backdrop';
        body.appendChild(this._backdrop);
        body.classList.add('modal-open');
        if (scrollBarWidth !== 0) {
          body.style.paddingRight = scrollBarWidth + 'px';
        }
        // request property that requires layout to force a layout
        var x = this._backdrop.clientHeight;
        this._backdrop.classList.add('in');
        NodeListJS(this._backdrop).on('click', function () {
          return _this.trigger_close();
        });
      } else {
        NodeListJS(this._backdrop).on('transitionend', function () {
          NodeListJS(_this._backdrop).off();
          try {
            body.classList.remove('modal-open');
            body.style.paddingRight = '0';
            body.removeChild(_this._backdrop);
            _this._backdrop = null;
          } catch (e) {}
        });
        this._backdrop.className = 'aside-backdrop';
      }
    }
  },
  methods: {
    trigger: function trigger() {
      var _this2 = this;

      return {
        close: function close() {
          return _this2.trigger_close();
        },
        open: function open() {
          return _this2.trigger_open();
        }
      };
    },
    trigger_close: function trigger_close() {
      this.$emit('close');
    },
    trigger_open: function trigger_open() {
      this.$emit('open');
    }
  },
  mounted: function mounted() {
    var _this3 = this;

    this.$emit('trigger', function () {
      return _this3.trigger;
    });
  }
};

var buttonGroup = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { class: { 'btn-group': _vm.buttons, 'btn-group-justified': _vm.justified, 'btn-group-vertical': _vm.vertical }, attrs: { "data-toggle": _vm.buttons && 'buttons' } }, [_vm._t("default")], 2);
  },
  staticRenderFns: [],
  props: {
    buttons: { default: true },
    justified: { type: Boolean, default: false },
    type: { type: String, default: 'default' },
    value: { default: null },
    vertical: { type: Boolean, default: false }
  },
  data: function data() {
    this._btnGroup = true;
    return {
      val: this.value
    };
  },

  watch: {
    val: function val(_val) {
      this.$emit('input', _val);
    }
  }
};

// let coerce = {
//   interval: 'number'
// }

var carousel = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "carousel slide", attrs: { "data-ride": "carousel" } }, [_c('ol', { directives: [{ name: "show", rawName: "v-show", value: _vm.indicators, expression: "indicators" }], staticClass: "carousel-indicators" }, _vm._l(_vm.indicator_list, function (indicator, i) {
      return _c('li', { class: { active: i === _vm.index }, on: { "click": function click($event) {
            _vm.indicatorClick(i);
          } } }, [_c('span')]);
    })), _vm._v(" "), _c('div', { staticClass: "carousel-inner", attrs: { "role": "listbox" } }, [_vm._t("default")], 2), _vm._v(" "), _c('div', { directives: [{ name: "show", rawName: "v-show", value: _vm.controls, expression: "controls" }], staticClass: "carousel-controls hidden-xs" }, [_c('a', { staticClass: "left carousel-control", attrs: { "role": "button" }, on: { "click": _vm.prev } }, [_c('span', { staticClass: "glyphicon glyphicon-chevron-left", attrs: { "aria-hidden": "true" } })]), _vm._v(" "), _c('a', { staticClass: "right carousel-control", attrs: { "role": "button" }, on: { "click": _vm.next } }, [_c('span', { staticClass: "glyphicon glyphicon-chevron-right", attrs: { "aria-hidden": "true" } })])])]);
  },
  staticRenderFns: [],
  props: {
    indicators: {
      type: Boolean,
      default: true
    },
    controls: {
      type: Boolean,
      default: true
    },
    interval: {
      type: Number,
      default: 5000
    }
  },
  data: function data() {
    return {
      indicator_list: [],
      index: 0,
      isAnimating: false
    };
  },

  watch: {
    index: function index(newVal, oldVal) {
      this.slide(newVal > oldVal ? 'left' : 'right', newVal, oldVal);
    }
  },
  methods: {
    indicatorClick: function indicatorClick(index) {
      if (this.isAnimating || this.index === index) return false;
      this.isAnimating = true;
      this.index = index;
    },
    slide: function slide(direction, next, prev) {
      var _this = this;

      if (!this.$el) {
        return;
      }
      var $slider = NodeListJS('.item', this.$el);
      if (!$slider.length) {
        return;
      }
      var selected = $slider[next] || $slider[0];
      NodeListJS(selected).addClass(direction === 'left' ? 'next' : 'prev');
      // request property that requires layout to force a layout
      var x = selected.clientHeight;
      NodeListJS([$slider[prev], selected]).addClass(direction).on('transitionend', function () {
        $slider.off('transitionend').className = 'item';
        NodeListJS(selected).addClass('active');
        _this.isAnimating = false;
      });
    },
    next: function next() {
      if (!this.$el || this.isAnimating) {
        return false;
      }
      this.isAnimating = true;
      this.index + 1 < NodeListJS('.item', this.$el).length ? this.index += 1 : this.index = 0;
    },
    prev: function prev() {
      if (!this.$el || this.isAnimating) {
        return false;
      }
      this.isAnimating = true;
      this.index === 0 ? this.index = NodeListJS('.item', this.$el).length - 1 : this.index -= 1;
    },
    toggleInterval: function toggleInterval(val) {
      if (val === undefined) {
        val = this._intervalID;
      }
      if (this._intervalID) {
        clearInterval(this._intervalID);
        delete this._intervalID;
      }
      if (val && this.interval > 0) {
        this._intervalID = setInterval(this.next, this.interval);
      }
    }
  },
  mounted: function mounted() {
    var _this2 = this;

    this.toggleInterval(true);
    NodeListJS(this.$el).on('mouseenter', function () {
      return _this2.toggleInterval(false);
    }).on('mouseleave', function () {
      return _this2.toggleInterval(true);
    });
  },
  beforeDestroy: function beforeDestroy() {
    this.toggleInterval(false);
    NodeListJS(this.$el).off('mouseenter mouseleave');
  }
};

var checkbox = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c(_vm.isButton ? 'a' : 'label', { tag: "a", class: [_vm.isButton ? 'btn btn-' + _vm.typeColor : 'open checkbox ' + _vm.typeColor, { active: _vm.checked, disabled: _vm.disabled, readonly: _vm.readonly }], on: { "click": _vm.toggle } }, [_vm.name ? _c('input', { attrs: { "type": "hidden", "name": _vm.name }, domProps: { "value": _vm.checked ? _vm.trueValue : _vm.falseValue } }) : _vm._e(), _vm._v(" "), !_vm.isButton ? _c('span', { staticClass: "icon dropdown-toggle", class: [_vm.checked ? 'btn-' + _vm.typeColor : '', { bg: _vm.typeColor === 'default' }] }) : _vm._e(), _vm._v(" "), !_vm.isButton && _vm.checked && _vm.typeColor === 'default' ? _c('span', { staticClass: "icon" }) : _vm._e(), _vm._v(" "), _vm._t("default")], 2);
  },
  staticRenderFns: [],
  props: {
    button: { type: Boolean, default: false },
    disabled: { type: Boolean, default: false },
    falseValue: { default: false },
    name: { type: String, default: null },
    readonly: { type: Boolean, default: false },
    trueValue: { default: true },
    type: { type: String, default: null },
    value: { default: false }
  },
  data: function data() {
    return {
      checked: this.value === this.trueValue
    };
  },

  computed: {
    isButton: function isButton() {
      return this.button || this._inGroup && this.$parent.buttons;
    },
    isFalse: function isFalse() {
      return this.value === this.falseValue;
    },
    isTrue: function isTrue() {
      return this.value === this.trueValue;
    },
    parentValue: function parentValue() {
      return this._ingroup && this.$parent.val;
    },
    typeColor: function typeColor() {
      return this.type || this.$parent && this.$parent.type || 'default';
    }
  },
  watch: {
    checked: function checked(val, old) {
      var value = val ? this.trueValue : this.falseValue;
      this.$emit('checked', val);
      this.$emit('input', value);
      this.eval();
    },
    parentValue: function parentValue(val) {
      var checked = val === this.trueValue;
      if (this.checked !== checked) {
        this.checked = checked;
      }
    },
    value: function value(val, old) {
      var checked = val === this.trueValue;
      if (this.checked !== checked) {
        this.checked = checked;
      }
    }
  },
  created: function created() {
    var parent = this.$parent;
    if (parent && parent._btnGroup && !parent._radioGroup) {
      this._inGroup = true;
      parent._checkboxGroup = true;
      if (!(parent.val instanceof Array)) {
        parent.val = [];
      }
      this.eval();
    }
  },
  mounted: function mounted() {
    if (!this.$parent._checkboxGroup || typeof this.value === 'boolean') {
      return;
    }
    if (this.$parent.val.length) {
      // this.checked = ~this.$parent.val.indexOf(this.value)
      this.$emit('checked', ~this.$parent.val.indexOf(this.value));
    } else if (this.checked) {
      this.$parent.val.push(this.value);
    }
  },

  methods: {
    eval: function _eval() {
      if (this._inGroup) {
        var value = this.checked ? this.isTrue : this.isFalse;
        var index = this.$parent.val.indexOf(value);
        if (this.checked && !~index) this.$parent.val.push(value);
        if (!this.checked && ~index) this.$parent.val.splice(index, 1);
      }
    },
    toggle: function toggle() {
      if (this.disabled || this.readonly) {
        return;
      }
      this.checked = !this.checked;
    }
  }
};

// import $ from './utils/NodeList.js'

var datepicker = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "datepicker" }, [_c('input', { staticClass: "form-control datepicker-input", class: { 'with-reset-button': _vm.clearButton }, style: { width: _vm.width }, attrs: { "type": "text", "placeholder": _vm.placeholder }, domProps: { "value": _vm.value }, on: { "click": _vm.inputClick, "input": function input($event) {
          this.$emit('input', $event.target.value);
        } } }), _vm._v(" "), _vm.clearButton && _vm.value ? _c('button', { staticClass: "close", attrs: { "type": "button" }, on: { "click": function click($event) {
          _vm.value = '';
        } } }, [_c('span', [_vm._v("×")])]) : _vm._e(), _vm._v(" "), _c('div', { directives: [{ name: "show", rawName: "v-show", value: _vm.displayDayView, expression: "displayDayView" }], staticClass: "datepicker-popup" }, [_c('div', { staticClass: "datepicker-inner" }, [_c('div', { staticClass: "datepicker-body" }, [_c('div', { staticClass: "datepicker-ctrl" }, [_c('span', { staticClass: "datepicker-preBtn glyphicon glyphicon-chevron-left", attrs: { "aria-hidden": "true" }, on: { "click": function click($event) {
          _vm.preNextMonthClick(0);
        } } }), _vm._v(" "), _c('span', { staticClass: "datepicker-nextBtn glyphicon glyphicon-chevron-right", attrs: { "aria-hidden": "true" }, on: { "click": function click($event) {
          _vm.preNextMonthClick(1);
        } } }), _vm._v(" "), _c('p', { on: { "click": _vm.switchMonthView } }, [_vm._v(_vm._s(_vm.stringifyDayHeader(_vm.currDate)))])]), _vm._v(" "), _c('div', { staticClass: "datepicker-weekRange" }, _vm._l(_vm.text.daysOfWeek, function (w) {
      return _c('span', [_vm._v(_vm._s(w))]);
    })), _vm._v(" "), _c('div', { staticClass: "datepicker-dateRange" }, _vm._l(_vm.dateRange, function (d) {
      return _c('span', { class: d.sclass, on: { "click": function click($event) {
            _vm.daySelect(d.date, this);
          } } }, [_vm._v(_vm._s(d.text))]);
    }))])])]), _vm._v(" "), _c('div', { directives: [{ name: "show", rawName: "v-show", value: _vm.displayMonthView, expression: "displayMonthView" }], staticClass: "datepicker-popup" }, [_c('div', { staticClass: "datepicker-inner" }, [_c('div', { staticClass: "datepicker-body" }, [_c('div', { staticClass: "datepicker-ctrl" }, [_c('span', { staticClass: "datepicker-preBtn glyphicon glyphicon-chevron-left", attrs: { "aria-hidden": "true" }, on: { "click": function click($event) {
          _vm.preNextYearClick(0);
        } } }), _vm._v(" "), _c('span', { staticClass: "datepicker-nextBtn glyphicon glyphicon-chevron-right", attrs: { "aria-hidden": "true" }, on: { "click": function click($event) {
          _vm.preNextYearClick(1);
        } } }), _vm._v(" "), _c('p', { on: { "click": _vm.switchDecadeView } }, [_vm._v(_vm._s(_vm.stringifyYearHeader(_vm.currDate)))])]), _vm._v(" "), _c('div', { staticClass: "datepicker-monthRange" }, [_vm._l(_vm.text.months, function (m, index) {
      return [_c('span', { class: { 'datepicker-dateRange-item-active': _vm.text.months[_vm.parse(_vm.value).getMonth()] === m && _vm.currDate.getFullYear() === _vm.parse(_vm.value).getFullYear() }, on: { "click": function click($event) {
            _vm.monthSelect(index);
          } } }, [_vm._v(_vm._s(m.substr(0, 3)))])];
    })], 2)])])]), _vm._v(" "), _c('div', { directives: [{ name: "show", rawName: "v-show", value: _vm.displayYearView, expression: "displayYearView" }], staticClass: "datepicker-popup" }, [_c('div', { staticClass: "datepicker-inner" }, [_c('div', { staticClass: "datepicker-body" }, [_c('div', { staticClass: "datepicker-ctrl" }, [_c('span', { staticClass: "datepicker-preBtn glyphicon glyphicon-chevron-left", attrs: { "aria-hidden": "true" }, on: { "click": function click($event) {
          _vm.preNextDecadeClick(0);
        } } }), _vm._v(" "), _c('span', { staticClass: "datepicker-nextBtn glyphicon glyphicon-chevron-right", attrs: { "aria-hidden": "true" }, on: { "click": function click($event) {
          _vm.preNextDecadeClick(1);
        } } }), _vm._v(" "), _c('p', [_vm._v(_vm._s(_vm.stringifyDecadeHeader(_vm.currDate)))])]), _vm._v(" "), _c('div', { staticClass: "datepicker-monthRange decadeRange" }, [_vm._l(_vm.decadeRange, function (decade) {
      return [_c('span', { class: { 'datepicker-dateRange-item-active': _vm.parse(this.value).getFullYear() === decade.text }, on: { "click": function click($event) {
            $event.stopPropagation();_vm.yearSelect(decade.text);
          } } }, [_vm._v(_vm._s(decade.text))])];
    })], 2)])])])]);
  },
  staticRenderFns: [],
  props: {
    value: { type: String },
    format: { default: 'MM/dd/yyyy' },
    disabledDaysOfWeek: { type: Array, default: function _default() {
        return [];
      }
    },
    width: { type: String, default: '200px' },
    clearButton: { type: Boolean, default: false },
    lang: { type: String, default: navigator.language },
    placeholder: { type: String }
  },
  data: function data() {
    return {
      currDate: new Date(),
      dateRange: [],
      decadeRange: [],
      displayDayView: false,
      displayMonthView: false,
      displayYearView: false
    };
  },

  watch: {
    value: function value(val) {
      this.$emit('input', val);
    },
    currDate: function currDate() {
      this.getDateRange();
    }
  },
  computed: {
    text: function text() {
      return translations(this.lang);
    }
  },
  methods: {
    close: function close() {
      this.displayDayView = this.displayMonthView = this.displayYearView = false;
    },
    inputClick: function inputClick() {
      this.currDate = this.parse(this.value) || this.parse(new Date());
      if (this.displayMonthView || this.displayYearView) {
        this.displayDayView = false;
      } else {
        this.displayDayView = !this.displayDayView;
      }
    },
    preNextDecadeClick: function preNextDecadeClick(flag) {
      var year = this.currDate.getFullYear();
      var months = this.currDate.getMonth();
      var date = this.currDate.getDate();

      if (flag === 0) {
        this.currDate = new Date(year - 10, months, date);
      } else {
        this.currDate = new Date(year + 10, months, date);
      }
    },
    preNextMonthClick: function preNextMonthClick(flag) {
      var year = this.currDate.getFullYear();
      var month = this.currDate.getMonth();
      var date = this.currDate.getDate();

      if (flag === 0) {
        var preMonth = this.getYearMonth(year, month - 1);
        this.currDate = new Date(preMonth.year, preMonth.month, date);
      } else {
        var nextMonth = this.getYearMonth(year, month + 1);
        this.currDate = new Date(nextMonth.year, nextMonth.month, date);
      }
    },
    preNextYearClick: function preNextYearClick(flag) {
      var year = this.currDate.getFullYear();
      var months = this.currDate.getMonth();
      var date = this.currDate.getDate();

      if (flag === 0) {
        this.currDate = new Date(year - 1, months, date);
      } else {
        this.currDate = new Date(year + 1, months, date);
      }
    },
    yearSelect: function yearSelect(year) {
      this.displayYearView = false;
      this.displayMonthView = true;
      this.currDate = new Date(year, this.currDate.getMonth(), this.currDate.getDate());
    },
    daySelect: function daySelect(date, el) {
      if (this.$el.classList[0] === 'datepicker-item-disable') {
        return false;
      } else {
        this.currDate = date;
        this.value = this.stringify(this.currDate);
        this.displayDayView = false;
      }
    },
    switchMonthView: function switchMonthView() {
      this.displayDayView = false;
      this.displayMonthView = true;
    },
    switchDecadeView: function switchDecadeView() {
      this.displayMonthView = false;
      this.displayYearView = true;
    },
    monthSelect: function monthSelect(index) {
      this.displayMonthView = false;
      this.displayDayView = true;
      this.currDate = new Date(this.currDate.getFullYear(), index, this.currDate.getDate());
    },
    getYearMonth: function getYearMonth(year, month) {
      if (month > 11) {
        year++;
        month = 0;
      } else if (month < 0) {
        year--;
        month = 11;
      }
      return { year: year, month: month };
    },
    stringifyDecadeHeader: function stringifyDecadeHeader(date) {
      var yearStr = date.getFullYear().toString();
      var firstYearOfDecade = yearStr.substring(0, yearStr.length - 1) + 0;
      var lastYearOfDecade = parseInt(firstYearOfDecade, 10) + 10;
      return firstYearOfDecade + '-' + lastYearOfDecade;
    },
    stringifyDayHeader: function stringifyDayHeader(date) {
      return this.text.months[date.getMonth()] + ' ' + date.getFullYear();
    },
    parseMonth: function parseMonth(date) {
      return this.text.months[date.getMonth()];
    },
    stringifyYearHeader: function stringifyYearHeader(date) {
      return date.getFullYear();
    },
    stringify: function stringify(date) {
      var format = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.format;

      if (!date) date = this.parse();
      if (!date) return '';
      var year = date.getFullYear();
      var month = date.getMonth() + 1;
      var day = date.getDate();
      var monthName = this.parseMonth(date);

      return format.replace(/yyyy/g, year).replace(/MMMM/g, monthName).replace(/MMM/g, monthName.substring(0, 3)).replace(/MM/g, ('0' + month).slice(-2)).replace(/dd/g, ('0' + day).slice(-2)).replace(/yy/g, year).replace(/M(?!a)/g, month).replace(/d/g, day);
    },
    parse: function parse() {
      var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.value;

      var date = void 0;
      if (str.length === 10 && (this.format === 'dd-MM-yyyy' || this.format === 'dd/MM/yyyy')) {
        date = new Date(str.substring(6, 10), str.substring(3, 5), str.substring(0, 2));
      } else {
        date = new Date(str);
      }
      return isNaN(date.getFullYear()) ? new Date() : date;
    },
    getDayCount: function getDayCount(year, month) {
      var dict = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
      if (month === 1) {
        if (year % 400 === 0 || year % 4 === 0 && year % 100 !== 0) {
          return 29;
        }
      }
      return dict[month];
    },
    getDateRange: function getDateRange() {
      var _this = this;

      this.dateRange = [];
      this.decadeRange = [];
      var time = {
        year: this.currDate.getFullYear(),
        month: this.currDate.getMonth(),
        day: this.currDate.getDate()
      };
      var yearStr = time.year.toString();
      var firstYearOfDecade = yearStr.substring(0, yearStr.length - 1) + 0 - 1;
      for (var i = 0; i < 12; i++) {
        this.decadeRange.push({
          text: firstYearOfDecade + i
        });
      }

      var currMonthFirstDay = new Date(time.year, time.month, 1);
      var firstDayWeek = currMonthFirstDay.getDay() + 1;
      if (firstDayWeek === 0) {
        firstDayWeek = 7;
      }
      var dayCount = this.getDayCount(time.year, time.month);
      if (firstDayWeek > 1) {
        var preMonth = this.getYearMonth(time.year, time.month - 1);
        var prevMonthDayCount = this.getDayCount(preMonth.year, preMonth.month);
        for (var _i = 1; _i < firstDayWeek; _i++) {
          var dayText = prevMonthDayCount - firstDayWeek + _i + 1;
          this.dateRange.push({
            text: dayText,
            date: new Date(preMonth.year, preMonth.month, dayText),
            sclass: 'datepicker-item-gray'
          });
        }
      }

      var _loop = function _loop(_i2) {
        var date = new Date(time.year, time.month, _i2);
        var week = date.getDay();
        var sclass = '';
        _this.disabledDaysOfWeek.forEach(function (el) {
          if (week === parseInt(el, 10)) sclass = 'datepicker-item-disable';
        });
        if (_i2 === time.day) {
          if (_this.value) {
            var valueDate = _this.parse(_this.value);
            if (valueDate) {
              if (valueDate.getFullYear() === time.year && valueDate.getMonth() === time.month) {
                sclass = 'datepicker-dateRange-item-active';
              }
            }
          }
        }
        _this.dateRange.push({
          text: _i2,
          date: date,
          sclass: sclass
        });
      };

      for (var _i2 = 1; _i2 <= dayCount; _i2++) {
        _loop(_i2);
      }

      if (this.dateRange.length < 42) {
        var nextMonthNeed = 42 - this.dateRange.length;
        var nextMonth = this.getYearMonth(time.year, time.month + 1);

        for (var _i3 = 1; _i3 <= nextMonthNeed; _i3++) {
          this.dateRange.push({
            text: _i3,
            date: new Date(nextMonth.year, nextMonth.month, _i3),
            sclass: 'datepicker-item-gray'
          });
        }
      }
    }
  },
  mounted: function mounted() {
    var _this2 = this;

    var el = this.$el;
    this._blur = function (e) {
      if (!el.contains(e.target)) _this2.close();
    };
    this.$emit('child-created', this);
    this.currDate = this.parse(this.value) || this.parse(new Date());
    window.addEventListener('click', this._blur);
  },
  beforeDestroy: function beforeDestroy() {
    window.removeEventListner('click', this._blur);
  }
};

var dropdown = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c(_vm.isLi ? 'li' : 'div', { directives: [{ name: "click-outside", rawName: "v-click-outside", value: _vm.blur, expression: "blur" }], tag: "div", class: [{ open: _vm.show, disabled: _vm.disabled, dropdown: _vm.isLi, 'input-group-btn': _vm.inInput, 'btn-group': !_vm.isLi && !_vm.inInput }] }, [_vm._t("before"), _vm._v(" "), _vm._t("button", [_vm.isLi ? _c('a', { class: ['dropdown-toggle', _vm.buttonSize, { disabled: _vm.disabled }], attrs: { "role": "button" }, on: { "keyup": function keyup($event) {
          if (_vm._k($event.keyCode, "esc", 27)) {
            return;
          }_vm.show = false;
        } } }, [_vm._v("\n      " + _vm._s(_vm.text) + "\n      "), _c('span', { staticClass: "caret" })]) : _c('button', { class: ['btn btn-' + _vm.type, _vm.buttonSize, 'dropdown-toggle'], attrs: { "type": "button", "disabled": _vm.disabled }, on: { "keyup": function keyup($event) {
          if (_vm._k($event.keyCode, "esc", 27)) {
            return;
          }_vm.show = false;
        } } }, [_vm._v("\n      " + _vm._s(_vm.text) + "\n      "), _c('span', { staticClass: "caret" })])]), _vm._v(" "), _vm._t("dropdown-menu", [_c('ul', { staticClass: "dropdown-menu" }, [_vm._t("default")], 2)])], 2);
  },
  staticRenderFns: [],
  directives: {
    ClickOutside: ClickOutside
  },
  props: {
    disabled: { type: Boolean, default: false },
    size: { type: String, default: null },
    text: { type: String, default: null },
    type: { type: String, default: 'default' },
    value: { type: Boolean, default: false }
  },
  data: function data() {
    var show = this.value;
    return { show: show };
  },

  watch: {
    show: function show(val) {
      this.$emit('input', val);
    },
    value: function value(val) {
      this.show = val;
    }
  },
  computed: {
    buttonSize: function buttonSize() {
      return ~['lg', 'sm', 'xs'].indexOf(this.size) ? 'btn-' + this.size : '';
    },
    inInput: function inInput() {
      return this.$parent._input;
    },
    isLi: function isLi() {
      return this.$parent._isTabs || this.$parent._navbar || this.$parent.menu;
    },
    menu: function menu() {
      return !this.$parent || this.$parent.navbar;
    },
    slots: function slots() {
      return this._slotContents;
    },
    submenu: function submenu() {
      return this.$parent && (this.$parent.menu || this.$parent.submenu);
    }
  },
  methods: {
    blur: function blur() {
      this.show = false;
    }
  },
  mounted: function mounted() {
    var _this = this;

    var $el = NodeListJS(this.$el);
    $el.findChildren('a,button.dropdown-toggle').on('click', function (e) {
      e.preventDefault();
      if (!_this.disabled) {
        _this.show = !_this.show;
      }
      return false;
    });
    $el.findChildren('ul').on('click', 'li>a', function (e) {
      _this.show = false;
    });
  },
  beforeDestroy: function beforeDestroy() {
    NodeListJS(this.$el).findChildren('a,button,ul').off();
  }
};

// let coerce = {
//     enterSubmit: 'boolean',
//     icon: 'boolean'
// }

var formGroup = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('span', [_vm._t("default")], 2);
  },
  staticRenderFns: [],
  props: {
    enterSubmit: {
      type: Boolean,
      default: false
    },
    icon: {
      type: Boolean,
      default: false
    },
    lang: {
      type: String,
      default: navigator.language
    }
  },
  data: function data() {
    return {
      children: [],
      valid: null,
      timeout: null
    };
  },

  watch: {
    valid: function valid(val, old) {
      this.$emit('isvalid', val);
      this.$emit(!val ? 'invalid' : 'valid');
      if (val !== old && this._parent) this._parent.validate();
    }
  },
  methods: {
    validate: function validate() {
      var valid = true;
      this.children.some(function (el) {
        var v = el.validate ? el.validate() : el.valid !== undefined ? el.valid : el.required && !~['', null, undefined].indexOf(el.value);
        if (!v) valid = false;
        return !valid;
      });
      this.valid = valid;
      return valid === true;
    }
  },
  created: function created() {
    this._formGroup = true;
    var parent = this.$parent;
    while (parent && !parent._formGroup) {
      parent = parent.$parent;
    }
    if (parent && parent._formGroup) {
      parent.children.push(this);
      this._parent = parent;
    }
  },
  mounted: function mounted() {
    this.validate();
  },
  beforeDestroy: function beforeDestroy() {
    if (this._parent) {
      var index = this._parent.children.indexOf(this);
      this._parent.children.splice(index, 1);
    }
  }
};

var formValidator = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('span', [_vm._t("default")], 2);
  },
  staticRenderFns: [],
  props: {
    enterSubmit: { type: Boolean, default: false },
    icon: { type: Boolean, default: false },
    lang: { type: String, default: navigator.language },
    value: null
  },
  data: function data() {
    return {
      children: [],
      valid: null,
      timeout: null
    };
  },

  watch: {
    valid: function valid(val, old) {
      this.$emit('isvalid', val);
      this.$emit('input', val);
      this.$emit(!val ? 'invalid' : 'valid');
      if (val !== old && this._parent) this._parent.validate();
    }
  },
  methods: {
    validate: function validate() {
      var invalid = !this.children.some(function (el) {
        return el.validate ? el.validate() : el.valid !== undefined ? el.valid : el.required && !~['', null, undefined].indexOf(el.value);
      });
      this.valid = !invalid;
      return !invalid;
    }
  },
  created: function created() {
    this._formGroup = true;
    var parent = this.$parent;
    while (parent && !parent._formGroup) {
      parent = parent.$parent;
    }
    if (parent && parent._formGroup) {
      parent.children.push(this);
      this._parent = parent;
    }
  },
  mounted: function mounted() {
    this.validate();
  },
  beforeDestroy: function beforeDestroy() {
    if (this._parent) {
      var index = this._parent.children.indexOf(this);
      this._parent.children.splice(index, 1);
    }
  }
};

var DELAY = 300;

var input$1 = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "form-group", class: { validate: _vm.canValidate, 'has-feedback': _vm.icon, 'has-error': _vm.canValidate && _vm.valid === false, 'has-success': _vm.canValidate && _vm.valid } }, [_vm._t("label", [_vm.label ? _c('label', { staticClass: "control-label", on: { "click": _vm.focus } }, [_vm._v(_vm._s(_vm.label))]) : _vm._e()]), _vm._v(" "), _vm.$slots.before || _vm.$slots.after ? _c('div', { staticClass: "input-group" }, [_vm._t("before"), _vm._v(" "), _c(_vm.type == 'textarea' ? _vm.type : 'input', { directives: [{ name: "model", rawName: "v-model", value: _vm.val, expression: "val" }], ref: "input", tag: "textarea", staticClass: "form-control", attrs: { "cols": _vm.cols, "disabled": _vm.disabled, "list": _vm.id_datalist, "max": _vm.attr(_vm.max), "maxlength": _vm.maxlength, "min": _vm.attr(_vm.min), "name": _vm.name, "placeholder": _vm.placeholder, "readonly": _vm.readonly, "required": _vm.required, "rows": _vm.rows, "step": _vm.step, "title": _vm.attr(_vm.title), "type": _vm.type == 'textarea' ? null : _vm.type }, domProps: { "value": _vm._s(_vm.val) }, on: { "blur": _vm.emit, "focus": _vm.emit, "input": [function ($event) {
          if ($event.target.composing) {
            return;
          }_vm.val = $event.target.value;
        }, _vm.emit], "keyup": function keyup($event) {
          if (_vm._k($event.keyCode, "enter", 13)) {
            return;
          }_vm.type != 'textarea' && _vm.enterSubmit && _vm.submit();
        } } }), _vm._v(" "), _vm.clearButton && _vm.value ? _c('div', { class: { icon: _vm.icon } }, [_c('span', { staticClass: "close", on: { "click": function click($event) {
          _vm.value = '';
        } } }, [_vm._v("×")])]) : _vm._e(), _vm._v(" "), _vm.icon ? _c('div', { staticClass: "icon" }, [_vm.icon && _vm.valid !== null ? _c('span', { class: ['form-control-feedback glyphicon', 'glyphicon-' + (_vm.valid ? 'ok' : 'remove')], attrs: { "aria-hidden": "true" } }) : _vm._e()]) : _vm._e(), _vm._v(" "), _vm._t("after")], 2) : [_c(_vm.type == 'textarea' ? _vm.type : 'input', { directives: [{ name: "model", rawName: "v-model", value: _vm.val, expression: "val" }], ref: "input", tag: "textarea", staticClass: "form-control", attrs: { "cols": _vm.cols, "disabled": _vm.disabled, "list": _vm.id_datalist, "max": _vm.attr(_vm.max), "maxlength": _vm.maxlength, "min": _vm.attr(_vm.min), "name": _vm.name, "placeholder": _vm.placeholder, "readonly": _vm.readonly, "required": _vm.required, "rows": _vm.rows, "step": _vm.step, "title": _vm.attr(_vm.title), "type": _vm.type == 'textarea' ? null : _vm.type }, domProps: { "value": _vm._s(_vm.val) }, on: { "blur": _vm.emit, "focus": _vm.emit, "input": [function ($event) {
          if ($event.target.composing) {
            return;
          }_vm.val = $event.target.value;
        }, _vm.emit], "keyup": function keyup($event) {
          if (_vm._k($event.keyCode, "enter", 13)) {
            return;
          }_vm.type != 'textarea' && _vm.enterSubmit && _vm.submit();
        } } }), _vm._v(" "), _vm.clearButton && _vm.val ? _c('span', { staticClass: "close", on: { "click": function click($event) {
          _vm.val = '';
        } } }, [_vm._v("×")]) : _vm._e(), _vm._v(" "), _vm.icon && _vm.valid !== null ? _c('span', { class: ['form-control-feedback glyphicon', 'glyphicon-' + (_vm.valid ? 'ok' : 'remove')], attrs: { "aria-hidden": "true" } }) : _vm._e()], _vm._v(" "), _vm.id_datalist ? _c('datalist', { attrs: { "id": _vm.id_datalist } }, _vm._l(_vm.options, function (opc) {
      return _c('option', { domProps: { "value": opc } });
    })) : _vm._e(), _vm._v(" "), _vm.showHelp ? _c('div', { staticClass: "help-block", on: { "click": _vm.focus } }, [_vm._v(_vm._s(_vm.help))]) : _vm._e(), _vm._v(" "), _vm.showError ? _c('div', { staticClass: "help-block with-errors", on: { "click": _vm.focus } }, [_vm._v(_vm._s(_vm.errorText))]) : _vm._e()], 2);
  },
  staticRenderFns: [],
  props: {
    clearButton: { type: Boolean, default: false },
    cols: { type: Number, default: null },
    datalist: { type: Array, default: null },
    disabled: { type: Boolean, default: false },
    enterSubmit: { type: Boolean, default: false },
    error: { type: String, default: null },
    help: { type: String, default: null },
    hideHelp: { type: Boolean, default: true },
    icon: { type: Boolean, default: false },
    label: { type: String, default: null },
    lang: { type: String, default: navigator.language },
    mask: null,
    maskDelay: { type: Number, default: 100 },
    match: { type: String, default: null },
    max: { type: String, default: null },
    maxlength: { type: Number, default: null },
    min: { type: String, default: null },
    minlength: { type: Number, default: 0 },
    name: { type: String, default: null },
    pattern: { default: null },
    placeholder: { type: String, default: null },
    readonly: { type: Boolean, default: false },
    required: { type: Boolean, default: false },
    rows: { type: Number, default: 3 },
    step: { type: Number, default: null },
    type: { type: String, default: 'text' },
    url: { type: String, default: null },
    urlMap: { type: Function, default: null },
    validationDelay: { type: Number, default: 250 },
    value: { default: null }
  },
  data: function data() {
    var val = this.value;
    return {
      options: this.datalist,
      val: val,
      valid: null,
      timeout: null
    };
  },

  computed: {
    canValidate: function canValidate() {
      return !this.disabled && !this.readonly && (this.required || this.regex || this.nativeValidate || this.match !== null);
    },
    errorText: function errorText() {
      var value = this.value;
      var error = [this.error];
      if (!value && this.required) error.push('(' + this.text.required.toLowerCase() + ')');
      if (value && value.length < this.minlength) error.push('(' + this.text.minLength.toLowerCase() + ': ' + this.minlength + ')');
      return error.join(' ');
    },
    id_datalist: function id_datalist() {
      if (this.type !== 'textarea' && this.datalist instanceof Array) {
        if (!this._id_datalist) {
          if (!this.$root.id_datalist) {
            this.$root.id_datalist = 0;
          }
          this._id_datalist = 'input-datalist' + this.$root.id_datalist++;
        }
        return this._id_datalist;
      }
      return null;
    },
    input: function input() {
      return this.$refs.input;
    },
    nativeValidate: function nativeValidate() {
      return (this.input || {}).checkValidity && (~['url', 'email'].indexOf(this.type.toLowerCase()) || this.min || this.max);
    },
    regex: function regex() {
      return coerce.pattern(this.pattern);
    },
    showError: function showError() {
      return this.error && this.valid === false;
    },
    showHelp: function showHelp() {
      return this.help && (!this.showError || !this.hideHelp);
    },
    text: function text() {
      return translations(this.lang);
    },
    title: function title() {
      return this.errorText || this.help || '';
    }
  },
  watch: {
    datalist: function datalist(val, old) {
      if (val !== old && val instanceof Array) {
        this.options = val;
      }
    },
    match: function match(val) {
      this.eval();
    },
    options: function options(val, old) {
      if (val !== old) this.$emit('options', val);
    },
    url: function url(val) {
      this._url();
    },
    val: function val(_val, old) {
      var _this = this;

      this.$emit('input', _val);
      if (_val !== old) {
        if (this.mask instanceof Function) {
          _val = this.mask(_val || '');
          if (this.val !== _val) {
            if (this._timeout.mask) clearTimeout(this._timeout.mask);
            this._timeout.mask = setTimeout(function () {
              _this.val = _val;
            }, isNaN(this.maskDelay) ? 0 : this.maskDelay);
          }
        }
        this.eval();
      }
    },
    valid: function valid(val, old) {
      this.$emit('isvalid', val);
      this.$emit(!val ? 'invalid' : 'valid');
      if (this._parent) this._parent.validate();
    },
    value: function value(val) {
      if (this.val !== val) {
        this.val = val;
      }
    }
  },
  methods: {
    attr: function attr(value) {
      return ~['', null, undefined].indexOf(value) || value instanceof Function ? null : value;
    },
    emit: function emit(e) {
      this.$emit(e.type, e);
      if (e.type === 'blur' && this.canValidate) {
        this.valid = this.validate();
      }
    },
    eval: function _eval() {
      var _this2 = this;

      if (this._timeout.eval) clearTimeout(this._timeout.eval);
      if (!this.canValidate) {
        this.valid = true;
      } else {
        this._timeout.eval = setTimeout(function () {
          _this2.valid = _this2.validate();
          _this2._timeout.eval = null;
        }, this.validationDelay);
      }
    },
    focus: function focus() {
      this.input.focus();
    },
    submit: function submit() {
      if (this.$parent._formValidator) {
        return this.$parent.validate();
      }
      if (this.input.form) {
        var invalids = NodeListJS('.form-group.validate:not(.has-success)', this.input.form);
        if (invalids.length) {
          invalids.find('input,textarea,select')[0].focus();
        } else {
          this.input.form.submit();
        }
      }
    },
    validate: function validate() {
      if (!this.canValidate) {
        return true;
      }
      var value = (this.val || '').trim();
      if (!value) {
        return !this.required;
      }
      if (this.match !== null) {
        return this.match === value;
      }
      if (value.length < this.minlength) {
        return false;
      }
      if (this.nativeValidate && !this.input.checkValidity()) {
        return false;
      }
      if (this.regex) {
        if (!(this.regex instanceof Function ? this.regex(this.value) : this.regex.test(this.value))) {
          return false;
        }
      }
      return true;
    }
  },
  created: function created() {
    this._input = true;
    this._timeout = {};
    var parent = this.$parent;
    while (parent && !parent._formValidator) {
      parent = parent.$parent;
    }
    if (parent && parent._formValidator) {
      this._parent = parent;
      this._parent && this._parent.children.push(this);
    }
    this._url = delayer(function () {
      var _this3 = this;

      if (!this.url || !this.$http || this._loading) {
        return;
      }
      this._loading = true;
      this.$http.get(this.url).then(function (response) {
        var data = response.data instanceof Array ? response.data : [];
        try {
          data = JSON.parse(data);
        } catch (e) {}
        if (_this3.urlMap) {
          data = data.map(_this3.urlMap);
        }
        _this3.options = data;
        _this3.loading = false;
      }, function (response) {
        _this3.loading = false;
      });
    }, DELAY);
    if (this.url) this._url();
  },
  mounted: function mounted() {
    // $(this.input).on('focus', e => { this.$emit('focus', e) }).on('blur', e => {
    //   if (this.canValidate) { this.valid = this.validate() }
    //   this.$emit('blur', e)
    // })
  },
  beforeDestroy: function beforeDestroy() {
    // $(this.input).off()
    if (this._parent) {
      var index = this._parent.children.indexOf(this);
      this._parent.children.splice(index, 1);
    }
  }
};

var modal = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { class: ['modal', _vm.effect], attrs: { "role": "dialog" }, on: { "click": _vm.backClose, "transitionend": _vm.transitionend } }, [_c('div', { class: { 'modal-dialog': true, 'modal-lg': _vm.large, 'modal-sm': _vm.small }, style: { width: _vm.optionalWidth }, attrs: { "role": "document" } }, [_c('div', { staticClass: "modal-content" }, [_vm._t("modal-header", [_c('div', { staticClass: "modal-header" }, [_c('button', { staticClass: "close", attrs: { "type": "button" }, on: { "click": _vm.close } }, [_c('span', [_vm._v("×")])]), _vm._v(" "), _c('h4', { staticClass: "modal-title" }, [_vm._t("title", [_vm._v(_vm._s(_vm.title))])], 2)])]), _vm._v(" "), _vm._t("modal-body", [_c('div', { staticClass: "modal-body" }, [_vm._t("default")], 2)]), _vm._v(" "), _vm._t("modal-footer", [_c('div', { staticClass: "modal-footer" }, [_c('button', { staticClass: "btn btn-default", attrs: { "type": "button" }, on: { "click": _vm.close } }, [_vm._v(_vm._s(_vm.cancelText))]), _vm._v(" "), _c('button', { staticClass: "btn btn-primary", attrs: { "type": "button" }, on: { "click": _vm.ok } }, [_vm._v(_vm._s(_vm.okText))])])])], 2)])]);
  },
  staticRenderFns: [],
  props: {
    backdrop: { type: Boolean, default: true },
    callback: { type: Function, default: null },
    cancelText: { type: String, default: 'Close' },
    effect: { type: String, default: null },
    large: { type: Boolean, default: false },
    okText: { type: String, default: 'Save changes' },
    small: { type: Boolean, default: false },
    title: { type: String, default: '' },
    value: { type: Boolean, required: true },
    width: { default: null }
  },
  computed: {
    optionalWidth: function optionalWidth() {
      if (this.width === null) {
        return null;
      } else if (Number.isInteger(this.width)) {
        return this.width + 'px';
      }
      return this.width;
    }
  },
  watch: {
    value: function value(val) {
      this.transitionstart();
    }
  },
  methods: {
    backClose: function backClose(e) {
      if (this.backdrop && e.target === this.$el) {
        this.close();
      }
    },
    close: function close() {
      this.$emit('cancel');
      this.$emit('input', false);
    },
    ok: function ok() {
      if (this.callback instanceof Function) this.callback();
      this.$emit('ok');
    },
    transitionstart: function transitionstart() {
      var el = this.$el;
      var body = document.body;
      var scrollBarWidth = getScrollBarWidth();
      if (this.value) {
        el.querySelector('.modal-content').focus();
        el.style.display = 'block';
        setTimeout(function () {
          return el.classList.add('in');
        }, 0);
        body.classList.add('modal-open');
        if (scrollBarWidth !== 0) {
          body.style.paddingRight = scrollBarWidth + 'px';
        }
      } else {
        el.classList.remove('in');
      }
    },
    transitionend: function transitionend() {
      if (!this.value) {
        this.$el.style.display = 'none';
        var body = document.body;
        body.style.paddingRight = null;
        body.classList.remove('modal-open');
      }
    }
  }
};

var navbar = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('nav', { class: ['navbar', 'navbar-' + _vm.type, _vm.placement === 'static' ? 'navbar-static-top' : 'navbar-fixed-' + _vm.placement] }, [_c('div', { staticClass: "container-fluid" }, [_c('div', { staticClass: "navbar-header" }, [!_vm.$slots.collapse ? _c('button', { staticClass: "navbar-toggle collapsed", attrs: { "type": "button", "aria-expanded": "false" }, on: { "click": _vm.toggleCollapse } }, [_c('span', { staticClass: "sr-only" }, [_vm._v("Toggle navigation")]), _vm._v(" "), _c('span', { staticClass: "icon-bar" }), _vm._v(" "), _c('span', { staticClass: "icon-bar" }), _vm._v(" "), _c('span', { staticClass: "icon-bar" })]) : _vm._e(), _vm._v(" "), _vm._t("collapse"), _vm._v(" "), _vm._t("brand")], 2), _vm._v(" "), _c('div', { class: ['navbar-collapse', { collapse: _vm.collapsed }] }, [_c('ul', { staticClass: "nav navbar-nav" }, [_vm._t("default")], 2), _vm._v(" "), _vm.$slots.left ? _c('ul', { staticClass: "nav navbar-nav navbar-left" }, [_vm._t("left")], 2) : _vm._e(), _vm._v(" "), _vm.$slots.right ? _c('ul', { staticClass: "nav navbar-nav navbar-right" }, [_vm._t("right")], 2) : _vm._e()])])]);
  },
  staticRenderFns: [],
  props: {
    type: { type: String, default: 'default' },
    placement: { type: String, default: '' }
  },
  data: function data() {
    return {
      id: 'bs-example-navbar-collapse-1',
      collapsed: true,
      styles: {}
    };
  },

  computed: {
    slots: function slots() {
      return this._slotContents;
    }
  },
  methods: {
    toggleCollapse: function toggleCollapse(e) {
      e && e.preventDefault();
      this.collapsed = !this.collapsed;
    }
  },
  created: function created() {
    this._navbar = true;
  },
  mounted: function mounted() {
    var _this = this;

    try {
      (function () {
        var $dropdown = NodeListJS('.dropdown>[data-toggle="dropdown"]', _this.$el).parent();
        if ($dropdown) {
          $dropdown.on('click', '.dropdown-toggle', function (e) {
            e.preventDefault();
            $dropdown.each(function (content) {
              if (content.contains(e.target)) content.classList.toggle('open');
            });
          }).on('click', '.dropdown-menu>li>a', function (e) {
            $dropdown.each(function (content) {
              if (content.contains(e.target)) content.classList.remove('open');
            });
          }).onBlur(function (e) {
            $dropdown.each(function (content) {
              if (!content.contains(e.target)) content.classList.remove('open');
            });
          });
        }
      })();
    } catch (ex) {
      console.log('error finding dropdown');
    }

    NodeListJS(this.$el).on('click touchstart', 'li:not(.dropdown)>a', function (e) {
      setTimeout(function () {
        _this.collapsed = true;
      }, 200);
    }).onBlur(function (e) {
      if (!_this.$el.contains(e.target)) {
        _this.collapsed = true;
      }
    });
    var height = this.$el.offsetHeight;
    if (this.placement === 'top') {
      document.body.style.paddingTop = height + 'px';
    }
    if (this.placement === 'bottom') {
      document.body.style.paddingBottom = height + 'px';
    }
    if (this.$slots.collapse) NodeListJS('[data-toggle="collapse"]', this.$el).on('click', function (e) {
      return _this.toggleCollapse(e);
    });
  },
  beforeDestroy: function beforeDestroy() {
    NodeListJS('.dropdown', this.$el).off('click').offBlur();
    if (this.$slots.collapse) NodeListJS('[data-toggle="collapse"]', this.$el).off('click');
  }
};

var option = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _vm.loading ? _c('li', [_vm._t("default")], 2) : _vm._e();
  },
  staticRenderFns: [],
  props: { value: null },
  data: function data() {
    return { loading: true };
  },
  mounted: function mounted() {
    if (this.$parent._select) {
      if (!this.$parent.options) {
        this.$parent.options = [];
      }
      var el = {};
      el[this.$parent.optionsLabel] = this.$el.innerHTML;
      el[this.$parent.optionsValue] = this.value;
      this.$parent.options.push(el);
      this.loading = false;
    } else {
      console.warn('options only work inside a select component');
    }
  }
};

var panel = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { class: ['panel', _vm.panelType] }, [_c('div', { class: ['panel-heading', { 'accordion-toggle': _vm.inAccordion }], on: { "click": function click($event) {
          $event.preventDefault();_vm.inAccordion && _vm.toggle();
        } } }, [_vm._t("header", [_c('h4', { staticClass: "panel-title" }, [_vm._v(_vm._s(_vm.header))])])], 2), _vm._v(" "), _c('transition', { attrs: { "name": "collapse" } }, [_vm.open ? _c('div', { staticClass: "panel-collapse" }, [_c('div', { staticClass: "panel-body" }, [_vm._t("default")], 2)]) : _vm._e()])], 1);
  },
  staticRenderFns: [],
  props: {
    header: { type: String },
    isOpen: { type: Boolean, default: null },
    type: { type: String, default: null }
  },
  data: function data() {
    return {
      open: this.isOpen
    };
  },

  watch: {
    isOpen: function isOpen(val) {
      this.open = val;
    }
  },
  computed: {
    inAccordion: function inAccordion() {
      return this.$parent && this.$parent._isAccordion;
    },
    panelType: function panelType() {
      return 'panel-' + (this.type || this.$parent && this.$parent.type || 'default');
    }
  },
  methods: {
    toggle: function toggle() {
      this.open = !this.open;
      this.$emit('open', this);
    }
  },
  transitions: {
    collapse: {
      afterEnter: function afterEnter(el) {
        el.style.maxHeight = '';
        el.style.overflow = '';
      },
      beforeLeave: function beforeLeave(el) {
        el.style.maxHeight = el.offsetHeight + 'px';
        el.style.overflow = 'hidden';
        // Recalculate DOM before the class gets added.
        return el.offsetHeight;
      }
    }
  },
  created: function created() {
    if (this.isOpen === null) {
      this.open = !this.inAccordion;
    }
  }
};

var PopoverMixin = {
  props: {
    content: { type: String },
    effect: { type: String, default: 'fade' },
    header: { type: Boolean, default: true },
    placement: { type: String, default: 'top' },
    title: { type: String },
    trigger: { type: String }
  },
  data: function data() {
    return {
      position: {
        top: 0,
        left: 0
      },
      show: false
    };
  },

  methods: {
    toggle: function toggle(e) {
      var _this = this;

      if (e && this.trigger === 'contextmenu') e.preventDefault();
      if (!(this.show = !this.show)) {
        return;
      }
      this.$nextTick(function () {
        var popover = _this.$refs.popover;
        var trigger = _this.$refs.trigger.children[0];
        switch (_this.placement) {
          case 'top':
            _this.position.left = trigger.offsetLeft - popover.offsetWidth / 2 + trigger.offsetWidth / 2;
            _this.position.top = trigger.offsetTop - popover.offsetHeight;
            break;
          case 'left':
            _this.position.left = trigger.offsetLeft - popover.offsetWidth;
            _this.position.top = trigger.offsetTop + trigger.offsetHeight / 2 - popover.offsetHeight / 2;
            break;
          case 'right':
            _this.position.left = trigger.offsetLeft + trigger.offsetWidth;
            _this.position.top = trigger.offsetTop + trigger.offsetHeight / 2 - popover.offsetHeight / 2;
            break;
          case 'bottom':
            _this.position.left = trigger.offsetLeft - popover.offsetWidth / 2 + trigger.offsetWidth / 2;
            _this.position.top = trigger.offsetTop + trigger.offsetHeight;
            break;
          default:
            console.warn('Wrong placement prop');
        }
        popover.style.top = _this.position.top + 'px';
        popover.style.left = _this.position.left + 'px';
      });
    }
  },
  mounted: function mounted() {
    var trigger = this.$refs.trigger;
    if (!trigger) return console.error('Could not find trigger v-el in your component that uses popoverMixin.');

    if (this.trigger === 'focus' && !~trigger.tabIndex) {
      trigger = NodeListJS('a,input,select,textarea,button', trigger);
      if (!trigger.length) {
        trigger = null;
      }
    }
    if (trigger) {
      var events = { contextmenu: 'contextmenu', hover: 'mouseleave mouseenter', focus: 'blur focus' };
      NodeListJS(trigger).on(events[this.trigger] || 'click', this.toggle);
      this._trigger = trigger;
    }
  },
  beforeDestroy: function beforeDestroy() {
    if (this._trigger) NodeListJS(this._trigger).off();
  }
};

var popover = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('span', { ref: "trigger" }, [_vm._t("default"), _vm._v(" "), _vm.show ? _c('div', { ref: "popover", class: ['popover', _vm.placement], attrs: { "transition": _vm.effect } }, [_c('div', { staticClass: "arrow" }), _vm._v(" "), _vm.title ? _c('h3', { staticClass: "popover-title" }, [_vm._t("title", [_vm._v(_vm._s(_vm.title))])], 2) : _vm._e(), _vm._v(" "), _c('div', { staticClass: "popover-content" }, [_vm._t("content", [_c('span', { domProps: { "innerHTML": _vm._s(_vm.content) } })])], 2)]) : _vm._e()], 2);
  },
  staticRenderFns: [],
  mixins: [PopoverMixin],
  props: {
    trigger: { type: String, default: 'click' }
  }
};

var progressbar = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { class: ['progress-bar', 'progress-bar-' + _vm.type, { active: _vm.animated, 'progress-bar-striped': _vm.striped }], style: { width: _vm.nowNum + '%' }, domProps: { "textContent": _vm._s(_vm.labelBool ? _vm.nowNum + '%' : null) } });
  },
  staticRenderFns: [],
  props: {
    animated: { type: Boolean, default: false },
    label: { default: false },
    now: { required: true },
    striped: { type: Boolean, default: false },
    type: { type: String }
  },
  computed: {
    labelBool: function labelBool() {
      return coerce.boolean(this.label);
    },
    nowNum: function nowNum() {
      return coerce.number(this.now);
    }
  }
};

var radio = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c(_vm.buttonStyle ? 'label' : 'div', { tag: "div", class: [_vm.buttonStyle ? 'btn btn-' + _vm.typeColor : 'radio ' + _vm.typeColor, { active: _vm.active, disabled: _vm.disabled, readonly: _vm.readonly }], on: { "click": function click($event) {
          $event.preventDefault();_vm.toggle($event);
        } } }, [_vm.buttonStyle ? [_c('input', { directives: [{ name: "show", rawName: "v-show", value: !_vm.readonly, expression: "!readonly" }, { name: "model", rawName: "v-model", value: _vm.check, expression: "check" }], ref: "input", attrs: { "type": "radio", "autocomplete": "off", "name": _vm.name, "readonly": _vm.readonly, "disabled": _vm.disabled }, domProps: { "value": _vm.checkedValue, "checked": _vm._q(_vm.check, _vm.checkedValue) }, on: { "change": function change($event) {
          _vm.check = _vm.checkedValue;
        } } }), _vm._v(" "), _vm._t("default")] : _c('label', { staticClass: "open" }, [_c('input', { directives: [{ name: "model", rawName: "v-model", value: _vm.check, expression: "check" }], ref: "input", attrs: { "type": "radio", "autocomplete": "off", "name": _vm.name, "readonly": _vm.readonly, "disabled": _vm.disabled }, domProps: { "value": _vm.checkedValue, "checked": _vm._q(_vm.check, _vm.checkedValue) }, on: { "change": function change($event) {
          _vm.check = _vm.checkedValue;
        } } }), _vm._v(" "), _c('span', { staticClass: "icon dropdown-toggle", class: [_vm.active ? 'btn-' + _vm.typeColor : '', { bg: _vm.typeColor === 'default' }] }), _vm._v(" "), _vm.active && _vm.typeColor === 'default' ? _c('span', { staticClass: "icon" }) : _vm._e(), _vm._v(" "), _vm._t("default")], 2)], 2);
  },
  staticRenderFns: [],
  props: {
    button: { type: Boolean, default: false },
    checkedValue: { default: true },
    disabled: { type: Boolean, default: false },
    name: { type: String, default: null },
    readonly: { type: Boolean, default: false },
    type: { type: String, default: null },
    value: { default: false }
  },
  data: function data() {
    return {
      check: this.value
    };
  },

  computed: {
    active: function active() {
      return this.check === this.checkedValue;
    },
    parentValue: function parentValue() {
      return this._inGroup ? this.$parent.val === this.value : null;
    },
    buttonStyle: function buttonStyle() {
      return this.button || this._inGroup && this.$parent.buttons;
    },
    typeColor: function typeColor() {
      return this.type || this.$parent && this.$parent.type || 'default';
    }
  },
  watch: {
    check: function check(val) {
      if (this.checkedValue === val) {
        this.$emit('input', val);
        this.$emit('checked', true);
        if (this._inGroup) {
          this.$parent.val = val;
        }
      }
    },
    parentValue: function parentValue(val) {
      if (this.check !== val && this.checkedValue === val) {
        this.check = val;
      }
    },
    value: function value(val) {
      this.check = this.checkedValue === val ? val : null;
    }
  },
  created: function created() {
    var parent = this.$parent;
    if (parent && parent._btnGroup && !parent._checkboxGroup) {
      this._inGroup = true;
      parent._radioGroup = true;
    }
    if (this.$parent._radioGroup) {
      if (this.$parent.val) {
        this.check = this.$parent.val === this.checkedValue;
      } else if (this.check) {
        this.$parent.val = this.checkedValue;
      }
    }
  },

  methods: {
    focus: function focus() {
      this.$refs.input.focus();
    },
    toggle: function toggle() {
      if (this.disabled) {
        return;
      }
      this.focus();
      if (this.readonly) {
        return;
      }
      this.check = this.checkedValue;
      if (this._inGroup) {
        this.$parent.val = this.checkedValue;
      }
    }
  }
};

var timeout = {};
var select$1 = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { directives: [{ name: "click-outside", rawName: "v-click-outside", value: _vm.blur, expression: "blur" }], ref: "select", class: _vm.classes }, [_c('button', { staticClass: "form-control dropdown-toggle", attrs: { "type": "button", "disabled": _vm.disabled || !_vm.hasParent, "readonly": _vm.readonly }, on: { "click": function click($event) {
          _vm.toggle();
        }, "keyup": function keyup($event) {
          if (_vm._k($event.keyCode, "esc", 27)) {
            return;
          }_vm.show = false;
        } } }, [_c('span', { staticClass: "btn-content", domProps: { "innerHTML": _vm._s(_vm.loading ? _vm.text.loading : _vm.showPlaceholder || _vm.selected) } }), _vm._v(" "), _vm.clearButton && _vm.values.length ? _c('span', { staticClass: "close", on: { "click": function click($event) {
          _vm.clear();
        } } }, [_vm._v("×")]) : _vm._e()]), _vm._v(" "), _c('select', { directives: [{ name: "model", rawName: "v-model", value: _vm.val, expression: "val" }, { name: "show", rawName: "v-show", value: _vm.show, expression: "show" }], ref: "sel", staticClass: "secret", attrs: { "name": _vm.name, "multiple": _vm.multiple, "required": _vm.required, "readonly": _vm.readonly, "disabled": _vm.disabled }, on: { "change": function change($event) {
          _vm.val = Array.prototype.filter.call($event.target.options, function (o) {
            return o.selected;
          }).map(function (o) {
            var val = "_value" in o ? o._value : o.value;return val;
          })[0];
        } } }, [_vm.required ? _c('option', { attrs: { "value": "" }, domProps: { "value": "" } }) : _vm._e(), _vm._v(" "), _vm._l(_vm.list, function (option) {
      return _c('option', { domProps: { "value": option[_vm.optionsValue] } }, [_vm._v(_vm._s(option[_vm.optionsLabel]))]);
    })], 2), _vm._v(" "), _c('ul', { staticClass: "dropdown-menu" }, [_vm.list.length ? [_vm.canSearch ? _c('li', { staticClass: "bs-searchbox" }, [_c('input', { directives: [{ name: "model", rawName: "v-model", value: _vm.searchValue, expression: "searchValue" }], ref: "search", staticClass: "form-control", attrs: { "type": "text", "placeholder": _vm.searchText || _vm.text.search, "autocomplete": "off" }, domProps: { "value": _vm._s(_vm.searchValue) }, on: { "keyup": function keyup($event) {
          if (_vm._k($event.keyCode, "esc", 27)) {
            return;
          }_vm.show = false;
        }, "input": function input($event) {
          if ($event.target.composing) {
            return;
          }_vm.searchValue = $event.target.value;
        } } }), _vm._v(" "), _c('span', { directives: [{ name: "show", rawName: "v-show", value: _vm.searchValue, expression: "searchValue" }], staticClass: "close", on: { "click": _vm.clearSearch } }, [_vm._v("×")])]) : _vm._e(), _vm._v(" "), _vm.required && !_vm.clearButton ? _c('li', [_c('a', { on: { "mousedown": function mousedown($event) {
          $event.preventDefault();_vm.clear() && _vm.blur();
        } } }, [_vm._v(_vm._s(_vm.placeholder || _vm.text.notSelected))])]) : _vm._e(), _vm._v(" "), _vm._l(_vm.filteredOptions, function (option) {
      return _c('li', { attrs: { "id": option[_vm.optionsValue] } }, [_c('a', { on: { "mousedown": function mousedown($event) {
            $event.preventDefault();_vm.select(option[_vm.optionsValue]);
          } } }, [_c('span', { domProps: { "innerHTML": _vm._s(option[_vm.optionsLabel]) } }), _vm._v(" "), _c('span', { directives: [{ name: "show", rawName: "v-show", value: _vm.isSelected(option[_vm.optionsValue]), expression: "isSelected(option[optionsValue])" }], staticClass: "glyphicon glyphicon-ok check-mark" })])]);
    })] : _vm._e(), _vm._v(" "), _vm._t("default"), _vm._v(" "), _vm.notify && !_vm.closeOnSelect ? _c('transition', { attrs: { "name": "fadein" } }, [_c('div', { staticClass: "notify in" }, [_vm._v(_vm._s(_vm.limitText))])]) : _vm._e()], 2), _vm._v(" "), _vm.notify && _vm.closeOnSelect ? _c('transition', { attrs: { "name": "fadein" } }, [_c('div', { staticClass: "notify out" }, [_c('div', [_vm._v(_vm._s(_vm.limitText))])])]) : _vm._e()], 1);
  },
  staticRenderFns: [],
  directives: {
    ClickOutside: ClickOutside
  },
  props: {
    clearButton: { type: Boolean, default: false },
    closeOnSelect: { type: Boolean, default: false },
    disabled: { type: Boolean, default: false },
    lang: { type: String, default: navigator.language },
    limit: { type: Number, default: 1024 },
    minSearch: { type: Number, default: 0 },
    multiple: { type: Boolean, default: false },
    name: { type: String, default: null },
    options: { type: Array, default: function _default() {
        return [];
      }
    },
    optionsLabel: { type: String, default: 'label' },
    optionsValue: { type: String, default: 'value' },
    parent: { default: true },
    placeholder: { type: String, default: null },
    readonly: { type: Boolean, default: null },
    required: { type: Boolean, default: null },
    search: { type: Boolean, default: false },
    searchText: { type: String, default: null },
    url: { type: String, default: null },
    value: null
  },
  data: function data() {
    return {
      list: [],
      loading: null,
      searchValue: null,
      show: false,
      notify: false,
      val: null,
      valid: null
    };
  },

  computed: {
    canSearch: function canSearch() {
      return this.minSearch ? this.list.length >= this.minSearch : this.search;
    },
    classes: function classes() {
      return [{ open: this.show, disabled: this.disabled }, this.class, this.isLi ? 'dropdown' : this.inInput ? 'input-group-btn' : 'btn-group'];
    },
    filteredOptions: function filteredOptions() {
      var _this = this;

      var search = (this.searchValue || '').toLowerCase();
      return !search ? this.list : this.list.filter(function (el) {
        return ~el[_this.optionsValue].toLowerCase().search(search);
      });
    },
    hasParent: function hasParent() {
      return this.parent instanceof Array ? this.parent.length : this.parent;
    },
    inInput: function inInput() {
      return this.$parent._input;
    },
    isLi: function isLi() {
      return this.$parent._navbar || this.$parent.menu || this.$parent._tabset;
    },
    limitText: function limitText() {
      return this.text.limit.replace('{{limit}}', this.limit);
    },
    selected: function selected() {
      var _this2 = this;

      if (this.list.length === 0) {
        return '';
      }
      var sel = this.values.map(function (val) {
        return (_this2.list.find(function (o) {
          return o[_this2.optionsValue] === val;
        }) || {})[_this2.optionsLabel];
      }).filter(function (val) {
        return val !== undefined;
      });
      this.$emit('selected', sel);
      return sel.join(', ');
    },
    showPlaceholder: function showPlaceholder() {
      return this.values.length === 0 || !this.hasParent ? this.placeholder || this.text.notSelected : null;
    },
    text: function text() {
      return translations(this.lang);
    },
    values: function values() {
      return this.val instanceof Array ? this.val : ~[null, undefined].indexOf(this.val) ? [] : [this.val];
    },
    valOptions: function valOptions() {
      var _this3 = this;

      return this.list.map(function (el) {
        return el[_this3.optionsValue];
      });
    }
  },
  watch: {
    options: function options(_options) {
      if (_options instanceof Array) this.setOptions(_options);
    },
    show: function show(val) {
      if (val) {
        this.$refs.sel.focus();
        this.$refs.search && this.$refs.search.focus();
        // onBlur(this.$refs.select, e => { this.show = false })
      } else {
          // offBlur(this.$refs.select)
        }
    },
    url: function url() {
      this.urlChanged();
    },
    valid: function valid(val, old) {
      this.$emit('isvalid', val);
      this.$emit(!val ? 'invalid' : 'valid');
      if (val !== old && this._parent) this._parent.validate();
    },
    value: function value(val, old) {
      if (val !== old) {
        this.val = val;
      }
    },
    val: function val(_val, old) {
      var _this4 = this;

      if (_val !== old) {
        this.$emit('change', _val);
        this.$emit('input', _val);
      }
      if (_val instanceof Array && _val.length > this.limit) {
        this.val = _val.slice(0, this.limit);
        this.notify = true;
        if (timeout.limit) clearTimeout(timeout.limit);
        timeout.limit = setTimeout(function () {
          timeout.limit = false;
          _this4.notify = false;
        }, 1500);
      }
      this.valid = this.validate();
    }
  },
  methods: {
    blur: function blur() {
      this.show = false;
    },
    checkData: function checkData() {
      if (this.multiple) {
        if (this.limit < 1) {
          this.limit = 1;
        }
        if (!(this.val instanceof Array)) {
          this.val = this.val === null || this.val === undefined ? [] : [this.val];
        }
        var values = this.valOptions;
        this.val = this.val.filter(function (el) {
          return ~values.indexOf(el);
        });
        if (this.values.length > this.limit) {
          this.val = this.val.slice(0, this.limit);
        }
      } else {
        if (!~this.valOptions.indexOf(this.val)) {
          this.val = null;
        }
      }
    },
    clear: function clear() {
      if (this.disabled || this.readonly) {
        return;
      }
      this.val = this.val instanceof Array ? [] : null;
      this.toggle();
    },
    clearSearch: function clearSearch() {
      this.searchValue = '';
      this.$refs.search.focus();
    },
    isSelected: function isSelected(v) {
      return this.values.indexOf(v) > -1;
    },
    select: function select(v) {
      if (this.val instanceof Array) {
        if (~this.val.indexOf(v)) {
          var index = this.val.indexOf(v);
          this.val.splice(index, 1);
        } else {
          this.val.push(v);
        }
        if (this.closeOnSelect) {
          this.toggle();
        }
      } else {
        this.val = v;
        this.toggle();
      }
    },
    setOptions: function setOptions(options) {
      var _this5 = this;

      this.list = options.map(function (el) {
        if (el instanceof Object) {
          return el;
        }
        var obj = {};
        obj[_this5.optionsLabel] = el;
        obj[_this5.optionsValue] = el;
        return obj;
      });
      this.$emit('options', this.list);
    },
    toggle: function toggle() {
      this.show = !this.show;
    },
    urlChanged: function urlChanged() {
      var _this6 = this;

      if (!this.url || !this.$http) {
        return;
      }
      this.loading = true;
      this.$http.get(this.url).then(function (response) {
        var data = response.data instanceof Array ? response.data : [];
        try {
          data = JSON.parse(data);
        } catch (e) {}
        _this6.setOptions(data);
        _this6.loading = false;
        _this6.checkData();
      }, function (response) {
        _this6.loading = false;
      });
    },
    validate: function validate() {
      return !this.required ? true : this.val instanceof Array ? this.val.length > 0 : this.val !== null;
    }
  },
  created: function created() {
    this.setOptions(this.options);
    this.val = this.value;
    this._select = true;
    if (this.val === undefined || !this.parent) {
      this.val = null;
    }
    if (!this.multiple && this.val instanceof Array) {
      this.val = this.val[0];
    }
    this.checkData();
    if (this.url) this.urlChanged();
    var parent = this.$parent;
    while (parent && !parent._formGroup) {
      parent = parent.$parent;
    }
    if (parent && parent._formGroup) {
      this._parent = parent;
    }
  },
  mounted: function mounted() {
    if (this._parent) this._parent.children.push(this);
  },
  beforeDestroy: function beforeDestroy() {
    if (this._parent) {
      var index = this._parent.children.indexOf(this);
      this._parent.children.splice(index, 1);
    }
  }
};

var slider = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "item" }, [_vm._t("default")], 2);
  },
  staticRenderFns: [],
  data: function data() {
    return {
      index: 0,
      show: false
    };
  },

  computed: {
    show: function show() {
      return this.$parent.index === this.index;
    }
  },
  mounted: function mounted() {
    for (var c in this.$parent.$children) {
      if (this.$parent.$children[c] === this) {
        this.index = parseInt(c, 10);
        break;
      }
    }
    //this.index = [...this.$el.parentNode.children].indexOf(this.$el)
    if (this.$parent.indicator) this.$parent.indicator.push(this.index);

    if (this.index === 0) {
      this.$el.classList.add('active');
    }
  }
};

var MIN_WAIT = 500; // in ms

var spinner = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { directives: [{ name: "show", rawName: "v-show", value: _vm.active || _vm.locked, expression: "active||locked" }], class: ['spinner spinner-gritcode', _vm.spinnerSize, { 'spinner-fixed': _vm.fixed }] }, [_c('div', { staticClass: "spinner-wrapper" }, [_c('div', { staticClass: "spinner-circle" }), _vm._v(" "), _c('div', { staticClass: "spinner-text" }, [_vm._v(_vm._s(_vm.text))])])]);
  },
  staticRenderFns: [],
  props: {
    fixed: { type: Boolean, default: false },
    global: { type: Boolean, default: false },
    size: { type: String, default: 'md' },
    text: { type: String, default: '' },
    value: { default: false }
  },
  data: function data() {
    return {
      active: this.value,
      locked: false
    };
  },

  computed: {
    spinnerSize: function spinnerSize() {
      return 'spinner-' + (this.size ? this.size : 'sm');
    }
  },
  watch: {
    active: function active(val, old) {
      if (val !== old) this.$emit('input', val);
    },
    value: function value(val, old) {
      if (val !== old) {
        this[val ? 'show' : 'hide']();
      }
    }
  },
  methods: {
    hide: function hide() {
      var delay = 0;
      this.active = false;
    },
    show: function show(options) {
      if (options) {
        if (options.text) {
          this.text = options.text;
        }
        if (options.size) {
          this.size = options.size;
        }
        if (options.fixed) {
          this.fixed = options.fixed;
        }
      }
      // block scrolling when spinner is on
      this._body.style.overflowY = 'hidden';
      // activate spinner
      this._started = new Date();
      this.active = true;
      this.locked = true;
      this._unlock();
    }
  },
  created: function created() {
    this._body = document.body;
    this._bodyOverflow = document.body.style.overflowY;
    this._unlock = delayer(function () {
      this.locked = false;
      this._body.style.overflowY = this._bodyOverflow;
    }, MIN_WAIT);
    if (this.global) {
      if (!this.$root._globalSpinner) {
        this.$root._globalSpinner = true;
        var self = this;
        this._global = {
          hide: function hide() {
            self.hide();
          },
          show: function show() {
            self.show();
          }
        };
        this.$root.$on('spinner::show', this._global.show);
        this.$root.$on('spinner::hide', this._global.hide);
      }
    }
  },
  beforeDestroy: function beforeDestroy() {
    if (this._global) {
      this.$root.$off('spinner::show', this._global.show);
      this.$root.$off('spinner::hide', this._global.hide);
      delete this.$root._globalSpinner;
    }
    clearTimeout(this._spinnerAnimation);
    this._body.style.overflowY = this._bodyOverflow;
  }
};

var tab = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { ref: "panel", class: ['tab-pane', { 'active fade': _vm.active, 'in': _vm.fadein }], attrs: { "role": "tabpanel" } }, [_vm._t("default")], 2);
  },
  staticRenderFns: [],
  props: {
    disabled: { type: Boolean, default: false },
    header: { type: String }
  },
  data: function data() {
    return {
      fadein: false
    };
  },

  computed: {
    active: function active() {
      var _this = this;

      var active = !this._tabs || this._tabs.show === this;
      this.fadein = false;
      if (active) {
        setTimeout(function () {
          _this.fadein = true;
        }, 0);
      }
      return active;
    },
    index: function index() {
      return this._tabs.tabs.indexOf(this);
    },
    transition: function transition() {
      return this._tabs ? this._tabs.effect : null;
    }
  },
  created: function created() {
    this._isTab = true;
    var tabs = this;
    while (!this._tabs && tabs.$parent) {
      if (tabs._isTabGroup) {
        tabs.tabs.push(this);
        this._tabGroup = tabs;
      }
      if (tabs._isTabs) {
        tabs.tabs.push(this);
        this._tabs = tabs;
        if (!this._tabGroup) tabs.headers.push(this);
      }
      tabs = tabs.$parent;
    }
    if (!this._tabs) throw Error('tab depend on tabs.');
  },
  beforeDestroy: function beforeDestroy() {
    var _this2 = this;

    if (this._tabGroup) {
      this._tabGroup.tabs = this._tabGroup.tabs.filter(function (el) {
        return el !== _this2;
      });
    }
    if (this._tabs) {
      this._tabs.tabs = this._tabs.tabs.filter(function (el) {
        return el !== _this2;
      });
    }
    if (this._tabs) {
      if (this._tabs.active === this.index) {
        this._tabs.index = 0;
      }
      if (this._ingroup) {
        var id = this.$parent.tabs.indexOf(this);
        if (~id) this.$parent.tabs.splice(id, 1);
      }
    }
    if (this._tabs) {
      var _id = this._tabs.tabs.indexOf(this);
      if (~_id) this._tabs.tabs.splice(_id, 1);
    }
  }
};

var tabGroup = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('span', [_vm._t("default")], 2);
  },
  staticRenderFns: [],
  props: {
    disabled: { type: Boolean, default: false },
    header: { type: String }
  },
  data: function data() {
    return {
      show: false,
      tabs: []
    };
  },

  computed: {
    active: function active() {
      return ~this.tabs.indexOf(this._tabs.show);
    }
  },
  methods: {
    blur: function blur() {
      this.show = false;
    },
    toggle: function toggle() {
      this.show = !this.show;
    }
  },
  created: function created() {
    this._isTabGroup = true;
    if (this.$parent) {
      if (this.$parent._isTabGroup) throw Error('Can\'t nest tab-groups.');
      if (!this.$parent._isTabs) throw Error('tab-group depend on tabs.');
    }
    this._tabs = this.$parent;
    this._tabs.headers.push(this);
  }
};

var tabs = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { attrs: { "tabs": "" } }, [_c('ul', { class: _vm.navStyleClass, attrs: { "role": "tablist" } }, [_vm._l(_vm.headers, function (header) {
      return [header._isTab ? _c('li', { class: { active: header.active, disabled: header.disabled }, on: { "click": function click($event) {
            $event.preventDefault();_vm.select(header);
          } } }, [_vm._t("header", [_c('a', { attrs: { "href": "#" }, domProps: { "innerHTML": _vm._s(header.header) } })])], 2) : _vm._e(), _vm._v(" "), header._isTabGroup ? _c('dropdown', { class: { active: header.active }, attrs: { "text": header.header, "disabled": header.disabled } }, _vm._l(header.tabs, function (tab) {
        return _c('li', { class: { disabled: tab.disabled } }, [_c('a', { attrs: { "href": "#" }, on: { "click": function click($event) {
              $event.preventDefault();_vm.select(tab);
            } } }, [_vm._v(_vm._s(tab.header))])]);
      })) : _vm._e()];
    })], 2), _vm._v(" "), _c('div', { staticClass: "tab-content" }, [_vm._t("default")], 2)]);
  },
  staticRenderFns: [],
  components: {
    dropdown: dropdown
  },
  props: {
    // effect: {type: String, default: 'fadein'},
    justified: false,
    navStyle: { type: String, default: null },
    value: { type: Number, default: 0 }
  },
  data: function data() {
    var index = this.value || 0;
    return {
      index: index,
      headers: [],
      tabs: []
    };
  },

  watch: {
    index: function index(val) {
      this.$emit('active', val);
      this.$emit('input', val);
    },
    value: function value(val) {
      this.index = val;
    }
  },
  computed: {
    navStyleClass: function navStyleClass() {
      return ['nav', ~['pills', 'stacked'].indexOf(this.navStyle) ? 'nav-' + this.navStyle : 'nav-tabs', {
        'nav-justified': coerce.boolean(this.justified),
        'nav-pills': this.navStyle === 'stacked'
      }];
    },
    show: function show() {
      return this.tabs[this.index] || this.tabs[0];
    }
  },
  methods: {
    select: function select(tab) {
      if (!tab.disabled) {
        this.index = this.tabs.indexOf(tab);
      }
    }
  },
  created: function created() {
    this._isTabs = true;
  }
};

var toggleButton = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('a', { class: ['btn', _vm.type], attrs: { "href": "javascript:void(0)" }, on: { "click": function click($event) {
          _vm.active = !_vm.active;
        } } }, [_c('span', { class: ['glyphicon', 'glyphicon-' + (_vm.value ? 'ok' : 'remove')] }), _vm._v(" "), _vm._t("default"), _vm._v(" "), _vm.name ? _c('input', { attrs: { "type": "hidden", "name": _vm.name }, domProps: { "value": _vm.active ? 1 : 0 } }) : _vm._e()], 2);
  },
  staticRenderFns: [],
  props: {
    isTrue: { default: 'primary' },
    isFalse: { default: null },
    name: null,
    value: false
  },
  data: function data() {
    var active = coerce.boolean(this.value);
    return {
      active: active,
      types: {
        danger: 'btn-danger',
        info: 'btn-info',
        primary: 'btn-primary',
        success: 'btn-success',
        warning: 'btn-warning'
      }
    };
  },

  watch: {
    active: function active(val, old) {
      if (val !== old) {
        this.$emit('changed', val);
        this.$emit(val ? 'enabled' : 'disabled');
        this.$emit('input', val);
      }
    },
    value: function value(val, old) {
      if (val !== old) {
        this.active = coerce.boolean(this.value);
      }
    }
  },
  computed: {
    type: function type() {
      return this.types[this.value ? this.isTrue : this.isFalse] || 'btn-default';
    }
  }
};

var DELAY$1 = 300;

var typeahead = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { class: { 'open': _vm.showDropdown }, staticStyle: { "position": "relative" } }, [_c('input', { directives: [{ name: "model", rawName: "v-model", value: _vm.val, expression: "val" }], staticClass: "form-control", attrs: { "type": "text", "autocomplete": "off", "placeholder": _vm.placeholder }, domProps: { "value": _vm._s(_vm.val) }, on: { "blur": function blur($event) {
          _vm.showDropdown = false;
        }, "keydown": [function ($event) {
          if (_vm._k($event.keyCode, "down", 40)) {
            return;
          }_vm.down($event);
        }, function ($event) {
          if (_vm._k($event.keyCode, "enter", 13)) {
            return;
          }_vm.hit($event);
        }, function ($event) {
          if (_vm._k($event.keyCode, "esc", 27)) {
            return;
          }_vm.reset($event);
        }, function ($event) {
          if (_vm._k($event.keyCode, "up", 38)) {
            return;
          }_vm.up($event);
        }], "input": function input($event) {
          if ($event.target.composing) {
            return;
          }_vm.val = $event.target.value;
        } } }), _vm._v(" "), _c('ul', { ref: "dropdown", staticClass: "dropdown-menu" }, _vm._l(_vm.items, function (item, i) {
      return _c('li', { class: { 'active': _vm.isActive(i) } }, [_c('a', { on: { "mousedown": function mousedown($event) {
            $event.preventDefault();_vm.hit($event);
          }, "mousemove": function mousemove($event) {
            _vm.setActive(i);
          } } }, [_c(_vm.tmpl, { tag: "component", attrs: { "item": item } })], 1)]);
    }))]);
  },
  staticRenderFns: [],
  props: {
    async: { type: String },
    data: { type: Array },
    delay: { type: Number, default: DELAY$1 },
    asyncKey: { type: String, default: null },
    limit: { type: Number, default: 8 },
    matchCase: { type: Boolean, default: false },
    matchStart: { type: Boolean, default: false },
    onHit: {
      type: Function,
      default: function _default(item) {
        this.reset();
        this.value = item;
      }
    },
    placeholder: { type: String },
    template: { type: String },
    value: { type: String, default: '' }
  },
  data: function data() {
    return {
      showDropdown: false,
      noResults: true,
      current: 0,
      items: [],
      val: ''
    };
  },

  computed: {
    templateHtml: function templateHtml() {
      return typeof this.template === 'string' ? '<span>' + this.template + '</span>' : null;
    },
    tmpl: function tmpl() {
      return this._tmpl;
    }
  },
  watch: {
    val: function val(_val, old) {
      this.$emit('input', _val);
      if (_val !== old) this._update();
    },
    value: function value(val) {
      if (this.val !== val) {
        this.val = val;
      }
    }
  },
  methods: {
    setItems: function setItems(data) {
      var _this = this;

      if (this.async) {
        this.items = this.asyncKey ? data[this.asyncKey] : data;
        this.items = this.items.slice(0, this.limit);
      } else {
        this.items = (data || []).filter(function (value) {
          if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') {
            return true;
          }
          value = _this.matchCase ? value : value.toLowerCase();
          var query = _this.matchCase ? _this.val : _this.val.toLowerCase();
          return _this.matchStart ? value.indexOf(query) === 0 : value.indexOf(query) !== -1;
        }).slice(0, this.limit);
      }
      this.showDropdown = this.items.length > 0;
    },
    reset: function reset() {
      this.items = [];
      this.val = '';
      this.loading = false;
      this.showDropdown = false;
    },
    setActive: function setActive(index) {
      this.current = index;
    },
    isActive: function isActive(index) {
      return this.current === index;
    },
    hit: function hit(e) {
      e.preventDefault();
      this.onHit(this.items[this.current], this);
    },
    up: function up() {
      if (this.current > 0) this.current--;
    },
    down: function down() {
      if (this.current < this.items.length - 1) this.current++;
    }
  },
  created: function created() {
    this.val = this.value;
    this._tmpl = {
      template: this.templateHtml || '<strong v-html="item"></strong>',
      props: {
        item: { default: null }
      }
    };
    this._update = delayer(function () {
      var _this2 = this;

      if (!this.val) {
        this.reset();
        return false;
      }
      if (this.async) {
        getJSON(this.async + this.val).then(function (data) {
          _this2.setItems(data);
        });
      } else if (this.data) {
        this.setItems(this.data);
      }
    }, 'delay', DELAY$1);
    this._update();
  }
};

// Utils
// Directives
// Components
var directives = {
  ClickOutside: ClickOutside,
  Scroll: Scroll
};

var VueStrap = {
  directives: directives,
  utils: {
    $: NodeListJS,
    coerce: coerce
  },
  accordion: accordion,
  affix: affix,
  alert: alert,
  aside: aside,
  buttonGroup: buttonGroup,
  carousel: carousel,
  checkbox: checkbox,
  datepicker: datepicker,
  dropdown: dropdown,
  formGroup: formGroup,
  formValidator: formValidator,
  input: input$1,
  modal: modal,
  navbar: navbar,
  option: option,
  panel: panel,
  popover: popover,
  progressbar: progressbar,
  radio: radio,
  select: select$1,
  slider: slider,
  spinner: spinner,
  tab: tab,
  tabGroup: tabGroup,
  tabs: tabs,
  toggleButton: toggleButton,
  typeahead: typeahead
};

VueStrap.install = function (Vue) {
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = Object.keys(directives)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var name = _step.value;

      Vue.directive(name, directives[name]);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {
    for (var _iterator2 = Object.keys(VueStrap)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      var _name = _step2.value;

      if (_typeof(VueStrap[_name]) != 'object' || _name == 'directives' || _name == 'utils') {
        continue;
      }

      var component = VueStrap[_name];
      _name = _name.split(/([A-Z][^A-Z]+)/g).filter(function (v) {
        return v;
      }).map(function (v) {
        return v.toLowerCase();
      }).join('-');
      component.name = 'bs-' + _name;
      Vue.component(component.name, component);
    }
  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2.return) {
        _iterator2.return();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }
};

var Card = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "card-pf", class: { 'card-pf-accented': _vm.accented } }, [_vm.showHeader ? _c('div', { class: { 'card-pf-heading': _vm.showTitlesSeparator, 'card-pf-heading-no-bottom': !_vm.showTitlesSeparator } }, [_vm.showFilterInHeader ? _c('dropdown', { staticClass: "card-pf-time-frame-filter pull-right", attrs: { "text": _vm.currentFilter.label } }, _vm._l(_vm.filter.filters, function (item) {
      return _c('li', { class: { 'selected': item === _vm.currentFilter } }, [_c('a', { attrs: { "href": "javascript:void(0)", "role": "menuitem", "tabindex": "-1" }, on: { "click": function click($event) {
            _vm.filterClicked(item);
          } } }, [_vm._v("\n          " + _vm._s(item.label) + "\n        ")])]);
    })) : _vm._e(), _vm._v(" "), _c('h2', { staticClass: "card-pf-title" }, [_vm._v(_vm._s(_vm.title))])], 1) : _vm._e(), _vm._v(" "), _vm.subTitle ? _c('span', { staticClass: "card-pf-subtitle" }, [_vm._v(_vm._s(_vm.subTitle))]) : _vm._e(), _vm._v(" "), _c('div', { staticClass: "card-pf-body" }, [_vm._t("default")], 2), _vm._v(" "), _vm.showFooter || _vm.showFilterInFooter ? _c('div', { staticClass: "card-pf-footer" }, [_vm.showFilterInFooter ? _c('dropdown', { staticClass: "card-pf-time-frame-filter pull-right", attrs: { "text": _vm.currentFilter.label } }, _vm._l(_vm.filter.filters, function (item) {
      return _c('li', { class: { 'selected': item === _vm.currentFilter } }, [_c('a', { attrs: { "href": "javascript:void(0)", "role": "menuitem", "tabindex": "-1" }, on: { "click": function click($event) {
            _vm.filterClicked(item);
          } } }, [_vm._v("\n          " + _vm._s(item.label) + "\n        ")])]);
    })) : _vm._e(), _vm._v(" "), _vm.showFooter ? _c('p', [_vm.footHref ? _c('a', { class: { 'card-pf-link-with-icon': _vm.footIcon, 'card-pf-link': !_vm.footIcon }, attrs: { "href": _vm.footHref } }, [_vm.footIcon ? _c('span', { staticClass: "card-pf-footer-text", class: _vm.footIcon }) : _vm._e(), _vm._v(" "), _vm.footNote ? _c('span', { staticClass: "card-pf-footer-text" }, [_vm._v(_vm._s(_vm.footNote))]) : _vm._e()]) : [_vm.footIcon ? _c('span', { staticClass: "card-pf-footer-text", class: _vm.footIcon }) : _vm._e(), _vm._v(" "), _vm.footNote ? _c('span', { staticClass: "card-pf-footer-text" }, [_vm._v(_vm._s(_vm.footNote))]) : _vm._e()]], 2) : _vm._e()], 1) : _vm._e()]);
  },
  staticRenderFns: [],
  name: 'pf-card',

  components: {
    dropdown: VueStrap.dropdown
  },

  props: {
    title: String,
    subTitle: String,
    footNote: String,
    footHref: String,
    footIcon: String,
    filter: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    accented: {
      type: Boolean,
      default: true
    },
    showTitlesSeparator: {
      type: Boolean,
      default: true
    }
  },

  methods: {
    filterClicked: function filterClicked(filter) {
      this.$emit('filter', filter);
    }
  },

  computed: {
    currentFilter: function currentFilter() {
      if (!this.filter || !this.filter.filters) {
        return null;
      }
      if (this.filter.defaultFilter) {
        return this.filter.filters[this.filter.defaultFilter];
      }
      return this.filter.filters[0];
    },
    showFilterInHeader: function showFilterInHeader() {
      return this.filter && this.filter.filters && this.filter.position && this.filter.position === 'header';
    },
    showFilterInFooter: function showFilterInFooter() {
      return this.filter && this.filter.filters && this.filter.position && this.filter.position === 'footer';
    },
    showHeader: function showHeader() {
      return this.title || this.showFilterInHeader;
    },
    showFooter: function showFooter() {
      return this.footNote || this.footIcon;
    }
  }
};

var CardNotification = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return !_vm.disabled ? _c('span', { staticClass: "card-pf-aggregate-status-notification" }, [_c(_vm.href ? 'a' : 'span', { tag: "span", attrs: { "href": _vm.href } }, [_vm.iconClass ? _c('span', { class: _vm.iconClass }) : _vm._e(), _vm._v("\n    " + _vm._s(_vm.count) + "\n  ")])]) : _vm._e();
  },
  staticRenderFns: [],
  name: 'pf-card-notification',

  props: {
    count: [String, Number],
    href: String,
    iconClass: String
  },

  computed: {
    disabled: function disabled() {
      return !this.iconClass && !this.count && this.count !== 0;
    }
  }
};

var EmptyChart = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "empty-chart-content", style: {
        'height': _vm.height,
        'padding-top': _vm.padding
      } }, [_c('span', { staticClass: "pficon pficon-info" }), _vm._v(" "), _c('span', [_vm._v("No data available")])]);
  },
  staticRenderFns: [],
  name: 'pf-empty-chart',

  props: {
    height: {
      type: Number,
      default: 40
    }
  },

  computed: {
    padding: function padding() {
      return Math.min(Math.round((this.height - 40) / 2), 20);
    }
  }
};

var PfSort = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "sort-pf" }, [_c('bs-dropdown', { attrs: { "text": _vm.current.label } }, _vm._l(_vm.normFields, function (field, i) {
      return _c('li', { class: { 'selected': _vm.active == field.name } }, [_c('a', { staticClass: "sort-field", attrs: { "href": "javascript:void(0);", "role": "menuitem", "tabindex": "-1" }, on: { "click": function click($event) {
            _vm.select(field);
          } } }, [_vm._v("\n        " + _vm._s(field.label) + "\n      ")])]);
    })), _vm._v(" "), _c('button', { staticClass: "btn btn-link", attrs: { "type": "button" }, on: { "click": _vm.invert } }, [_c('span', { staticClass: "sort-direction", class: _vm.sortIconClass })])], 1);
  },
  staticRenderFns: [],
  name: 'pf-sort',

  components: {
    BsDropdown: VueStrap.dropdown
  },

  props: {
    fields: {
      type: [Array, Object],
      default: function _default() {
        return [];
      }
    },
    sortBy: String,
    direction: {
      type: String,
      default: 'ascending'
    }
  },

  data: function data() {
    return {
      normFields: [],
      active: '',
      ascending: true
    };
  },


  watch: {
    fields: {
      handler: function handler(fields) {
        var normFields = [];
        if (fields instanceof Array) {
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = fields[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var f = _step.value;

              normFields.push(this.fieldDefinition(f));
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        } else {
          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = undefined;

          try {
            for (var _iterator2 = Object.keys(fields)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var i = _step2.value;

              normFields.push(this.fieldDefinition(fields[i], i));
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }
        }
        this.normFields = normFields;
      },

      immediate: true
    },
    sortBy: {
      handler: function handler(sortBy) {
        this.active = sortBy;
      },

      immediate: true
    },
    direction: {
      handler: function handler() {
        this.ascending = this.direction == 'ascending';
      },

      immediate: true
    }
  },

  computed: {
    current: function current() {
      if (!this.active) {
        return {
          label: 'Sort by'
        };
      }
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = this.normFields[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var field = _step3.value;

          if (field.name == this.active) {
            return field;
          }
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }

      return {
        label: 'Sort by'
      };
    },
    sortIconClass: function sortIconClass() {
      var dir = this.ascending ? 'asc' : 'desc';
      var typ = this.current.type == 'numeric' ? 'numeric' : 'alpha';
      return 'fa fa-sort-' + typ + '-' + dir;
    }
  },

  methods: {
    fieldDefinition: function fieldDefinition(field, name) {
      if ((typeof field === 'undefined' ? 'undefined' : _typeof(field)) == 'object') {
        field = Object.assign({}, field);
      } else {
        field = {
          label: field
        };
      }
      field.name = name || field.label;
      if (!field.label) {
        field.label = name;
      }
      if (!field.type) {
        field.type = 'alpha';
      }
      return field;
    },
    select: function select(field) {
      this.active = field.name;
      this.$emit('change', this.active, this.ascending ? 'ascending' : 'descending');
    },
    invert: function invert() {
      this.ascending = !this.ascending;
      this.$emit('change', this.active, this.ascending ? 'ascending' : 'descending');
    }
  }
};

var PfColumnPicker = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('bs-popover', { staticClass: "column-picker", attrs: { "effect": "fade", "placement": "bottom" } }, [_c('button', { staticClass: "btn btn-link", attrs: { "type": "button" } }, [_c('span', { staticClass: "fa fa-columns" })]), _vm._v(" "), _vm._l(_vm.columns, function (column, i) {
      return _c('div', { staticClass: "checkbox", on: { "click": function click($event) {
            $event.stopPropagation();
          } }, slot: "content" }, [_c('label', [_c('input', { directives: [{ name: "model", rawName: "v-model", value: _vm.iValue, expression: "iValue" }], attrs: { "type": "checkbox" }, domProps: { "value": _vm.columnValue(column, i), "checked": Array.isArray(_vm.iValue) ? _vm._i(_vm.iValue, _vm.columnValue(column, i)) > -1 : _vm.iValue }, on: { "change": [function ($event) {
            var $$a = _vm.iValue,
                $$el = $event.target,
                $$c = $$el.checked ? true : false;if (Array.isArray($$a)) {
              var $$v = _vm.columnValue(column, i),
                  $$i = _vm._i($$a, $$v);if ($$c) {
                $$i < 0 && (_vm.iValue = $$a.concat($$v));
              } else {
                $$i > -1 && (_vm.iValue = $$a.slice(0, $$i).concat($$a.slice($$i + 1)));
              }
            } else {
              _vm.iValue = $$c;
            }
          }, _vm.setValue] } }), _vm._v("\n      " + _vm._s(column) + "\n    ")])]);
    })], 2);
  },
  staticRenderFns: [],
  name: 'pf-column-picker',

  components: {
    BsPopover: VueStrap.popover
  },

  props: {
    columns: {
      type: [Array, Object],
      default: function _default() {
        return [];
      }
    },
    value: {
      type: Array,
      default: function _default() {
        return [];
      }
    }
  },

  data: function data() {
    return {
      iValue: []
    };
  },
  mounted: function mounted() {
    this.iValue = this.value;
  },


  methods: {
    columnValue: function columnValue(column, i) {
      return this.columns instanceof Array ? column : i;
    },
    setValue: function setValue() {
      var columns = this.columns instanceof Array ? this.columns : Object.keys(this.columns);
      var sortedValue = [];
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = columns[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var value = _step.value;

          if (this.iValue.indexOf(value) >= 0) {
            sortedValue.push(value);
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      this.$emit('input', sortedValue);
    }
  },

  watch: {
    value: function value(_value) {
      if (_value != this.iValue) {
        this.iValue = _value.slice(0);
      }
    }
  }
};

var Toolbar = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "clearfix toolbar-pf", class: {
        'table-view-pf-toolbar': _vm.attached
      }, attrs: { "_v-3RyaW5nJyk": "" } }, [_c('div', { staticClass: "col-sm-12" }, [_c('form', { staticClass: "toolbar-pf-actions", class: { 'no-filter-results': !_vm.showResultFilter }, on: { "submit": function submit($event) {
          $event.preventDefault();
        } } }, [_vm.showFilter ? _c('pf-filter-fields', { attrs: { "fields": _vm.filterFields }, on: { "filter": _vm.addFilter } }) : _vm._e(), _vm._v(" "), _vm.showSorter || _vm.showColumnPicker ? _c('div', { staticClass: "form-group" }, [_vm.showSorter ? _c('pf-sort', { attrs: { "fields": _vm.sortFields, "sortBy": _vm.sortBy, "direction": _vm.sortDirection }, on: { "change": _vm.setSortBy } }) : _vm._e(), _vm._v(" "), _vm.showColumnPicker ? _c('pf-column-picker', { ref: "colpicker", attrs: { "columns": _vm.columns, "value": _vm.pickedColumns }, on: { "input": _vm.setPickedColumns } }) : _vm._e()], 1) : _vm._e(), _vm._v(" "), _vm.$slots.default ? _c('div', { staticClass: "toolbar-actions", class: {
        'form-group': !_vm.hasFindView,
        'pull-right': !_vm.hasFindView,
        'toolbar-pf-action-right': !_vm.hasFindView
      } }, [_vm.showCount && !_vm.hasFindView ? _c('h5', { staticClass: "form-group" }, [_vm._v("\n          " + _vm._s(_vm.resultCount) + " Results\n        ")]) : _vm._e(), _vm._v(" "), _c('div', { staticClass: "form-group" }, [_vm._t("default")], 2)]) : _vm._e(), _vm._v(" "), _vm.hasFindView ? _c('div', { staticClass: "toolbar-pf-action-right" }, [_vm.showCount && _vm.hasFindView ? _c('h5', { staticClass: "form-group" }, [_vm._v("\n          " + _vm._s(_vm.resultCount) + " Results\n        ")]) : _vm._e(), _vm._v(" "), _c('div', { staticClass: "form-group toolbar-pf-view-selector" }, _vm._l(_vm.viewList, function (viewData, name) {
      return _c('button', { staticClass: "btn btn-link", class: { 'active': _vm.view == name, 'disabled': viewData.disabled }, attrs: { "title": viewData.title }, on: { "click": function click($event) {
            _vm.activeView = name;
          } } }, [_c('i', { staticClass: "view-selector", class: [viewData.iconClass] })]);
    }))]) : _vm._e()], 1), _vm._v(" "), _vm.showResultFilter ? _c('pf-filter-results', { attrs: { "count": _vm.resultCount, "filters": _vm.activeFilters } }) : _vm._e()], 1)]);
  },
  staticRenderFns: [],
  name: 'pf-toolbar',

  components: {
    PfSort: PfSort,
    PfColumnPicker: PfColumnPicker
  },

  props: {
    view: String,
    views: {
      type: [Object, String],
      default: function _default() {
        return {};
      }
    },
    columns: {
      type: [Array, Object],
      default: function _default() {
        return [];
      }
    },
    pickedColumns: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    filterFields: {
      type: [Array, Object],
      default: function _default() {
        return {};
      }
    },
    filters: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    sortBy: String,
    sortDirection: String,
    sortFields: {
      type: [Array, Object],
      default: function _default() {
        return [];
      }
    },
    resultCount: Number,
    attached: Boolean
  },

  data: function data() {
    return {
      activeView: null,
      activeFilters: []
    };
  },
  mounted: function mounted() {
    this.activeView = this.view;
  },


  methods: {
    setSortBy: function setSortBy(field, direction) {
      this.$emit('sort-by', field, direction);
    },
    clearFilter: function clearFilter(i) {
      this.activeFilters.splice(i, 1);
    },
    clearAllFilters: function clearAllFilters() {
      this.activeFilters = [];
    },
    addFilter: function addFilter(filter) {
      this.activeFilters.push(filter);
    },
    setPickedColumns: function setPickedColumns(columns) {
      this.$emit('columns', columns);
    }
  },

  computed: {
    showSorter: function showSorter() {
      return this.sortFields instanceof Array ? this.sortFields.length : Object.keys(this.sortFields).length;
    },
    showFilter: function showFilter() {
      return Object.keys(this.filterFields).length;
    },
    showColumnPicker: function showColumnPicker() {
      return (this.activeView == 'table' || !Object.keys(this.viewList).length) && this.columns.length;
    },
    showCount: function showCount() {
      return !this.showResultFilter && typeof this.resultCount != 'undefined';
    },
    hasFindView: function hasFindView() {
      return Object.keys(this.viewList).length;
    },
    viewList: function viewList() {
      if (typeof this.views != 'string') {
        return this.views;
      }

      var viewList = {};
      var presets = this.views.split(',').map(function (v) {
        return v.trim();
      });
      if (presets.indexOf('table') > -1) {
        viewList.table = {
          iconClass: 'fa fa-table'
        };
      }
      if (presets.indexOf('card') > -1) {
        viewList.card = {
          iconClass: 'fa fa-th'
        };
      }
      if (presets.indexOf('list') > -1) {
        viewList.list = {
          iconClass: 'fa fa-th-list'
        };
      }
      return viewList;
    },
    showResultFilter: function showResultFilter() {
      return this.activeFilters.length;
    }
  },

  watch: {
    filters: {
      handler: function handler() {
        this.activeFilters = this.filters;
      },

      immediate: true
    },
    view: function view() {
      this.activeView = this.view;
    },

    views: {
      handler: function handler() {
        if (!this.views[this.activeView]) {
          var names = Object.keys(this.views);
          if (names.length > 0) {
            this.activeView = names[0];
          }
        }
      },

      immediate: true
    },
    activeView: function activeView() {
      this.$emit('view', this.activeView);
    },
    activeFilters: function activeFilters() {
      this.$emit('filters', this.activeFilters);
    }
  }
};

var UtilizationBarChart = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "utilization-bar-chart-pf", class: { 'data-unavailable-pf': !_vm.dataAvailable } }, [!_vm.inline ? [_vm.title ? _c('div', { staticClass: "progress-description", domProps: { "innerHTML": _vm._s(_vm.title) } }) : _vm._e(), _vm._v(" "), _vm.dataAvailable ? _c('div', { staticClass: "progress progress-label-top-right" }, [_c('div', { directives: [{ name: "tooltip", rawName: "v-tooltip", value: _vm.percent + '% Used', expression: "percent + '% Used'" }], staticClass: "progress-bar", class: {
        'animate': _vm.animate,
        'progress-bar-success': _vm.isOk,
        'progress-bar-danger': _vm.isError,
        'progress-bar-warning': _vm.isWarning
      }, style: { width: _vm.percent + '%' }, attrs: { "aria-valuenow": _vm.percent, "aria-valuemin": "0", "aria-valuemax": "100" } }, [_c('span', { domProps: { "innerHTML": _vm._s(_vm.footerHTML) } })]), _vm._v(" "), _c('div', { directives: [{ name: "tooltip", rawName: "v-tooltip", value: 100 - _vm.percent + '% Available', expression: "(100 - percent) + '% Available'" }], staticClass: "progress-bar progress-bar-remaining", style: { width: 100 - _vm.percent + '%' } })]) : _vm._e()] : [_c('div', { staticClass: "progress-container progress-description-left progress-label-right", style: {
        'padding-left': _vm.titleWidth,
        'padding-right': _vm.footerWidth
      } }, [_vm.title ? _c('div', { staticClass: "progress-description", style: { 'max-width': _vm.titleWidth }, domProps: { "innerHTML": _vm._s(_vm.title) } }) : _vm._e(), _vm._v(" "), _vm.dataAvailable ? _c('div', { staticClass: "progress" }, [_c('div', { directives: [{ name: "tooltip", rawName: "v-tooltip", value: _vm.percent + '% Used', expression: "percent + '% Used'" }], staticClass: "progress-bar", class: {
        'animate': _vm.animate,
        'progress-bar-success': _vm.isOk,
        'progress-bar-danger': _vm.isError,
        'progress-bar-warning': _vm.isWarning
      }, style: { width: _vm.percent + '%' }, attrs: { "aria-valuenow": _vm.percent, "aria-valuemin": "0", "aria-valuemax": "100" } }, [_c('span', { style: { 'max-width': _vm.footerWidth }, domProps: { "innerHTML": _vm._s(_vm.footerHTML) } })]), _vm._v(" "), _c('div', { directives: [{ name: "tooltip", rawName: "v-tooltip", value: 100 - _vm.percent + '% Available', expression: "(100 - percent) + '% Available'" }], staticClass: "progress-bar progress-bar-remaining", style: { width: 100 - _vm.percent + '%' } })]) : _vm._e()])], _vm._v(" "), !_vm.dataAvailable ? _c('pf-empty-chart', { attrs: { "height": 45 } }) : _vm._e()], 2);
  },
  staticRenderFns: [],
  name: 'pf-utilization-bar-chart',

  props: {
    value: Number,
    total: Number,
    units: String,
    title: String,
    footer: String,
    footerFormat: {
      type: String,
      default: 'actual'
    },
    inline: Boolean,
    warning: Number,
    error: Number,
    titleWidth: Number,
    footerWidth: Number
  },

  data: function data() {
    return {
      animate: true
    };
  },
  mounted: function mounted() {
    this.$nextTick(function () {
      this.animate = false;
    }.bind(this));
  },


  computed: {
    dataAvailable: function dataAvailable() {
      return typeof this.value != 'undefined' && typeof this.total != 'undefined';
    },
    percent: function percent() {
      return Math.round(100 * this.value / this.total);
    },
    isError: function isError() {
      return this.percent >= this.error;
    },
    isWarning: function isWarning() {
      return !this.isError && this.percent >= this.warning;
    },
    isOk: function isOk() {
      return !this.isError && !this.isWarning;
    },
    footerHTML: function footerHTML() {
      if (this.footer) {
        return this.footer;
      }
      switch (this.footerFormat) {
        case 'percent':
          return "<strong>" + this.percent + "%</strong> used";
        default:
          if (this.inline) {
            return "<strong>" + this.value + " " + this.units + "</strong> used";
          }
          return "<strong>" + this.value + " of " + this.total + " " + this.units + "</strong> used";
      }
    }
  }
};

var FilterFields = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "filter-pf filter-fields form-group toolbar-pf-filter" }, [_c('div', { staticClass: "input-group" }, [_c('bs-dropdown', { staticClass: "input-group-btn", attrs: { "text": _vm.current.label } }, _vm._l(_vm.normFields, function (item, name) {
      return _c('li', [_c('a', { staticClass: "filter-field", attrs: { "role": "menuitem", "tabindex": "-1" }, on: { "click": function click($event) {
            _vm.selected = name;
          } } }, [_vm._v("\n          " + _vm._s(item.label) + "\n        ")])]);
    })), _vm._v(" "), _vm.isSelect ? _c('bs-select', { ref: "select", staticClass: "filter-select", attrs: { "placeholder": _vm.current.placeholder, "close-on-select": true }, on: { "input": _vm.set } }, [_vm._t("options", _vm._l(_vm.current.values, function (item) {
      return _c('bs-option', { attrs: { "value": item } }, [_vm._v(_vm._s(item))]);
    }), { field: _vm.current })], 2) : _c('div', [_c('input', { ref: "input", staticClass: "form-control", attrs: { "type": "text", "placeholder": _vm.current.placeholder }, domProps: { "value": _vm.value }, on: { "keyup": function keyup($event) {
          if (_vm._k($event.keyCode, "enter", 13)) {
            return;
          }$event.stopPropagation();_vm.set($event);
        } } })])], 1)]);
  },
  staticRenderFns: [],
  name: 'pf-filter-fields',

  components: {
    BsDropdown: VueStrap.dropdown,
    BsSelect: VueStrap.select,
    BsOption: VueStrap.option
  },

  props: {
    value: {
      type: String,
      default: ''
    },
    fields: {
      type: [Array, Object],
      default: function _default() {
        return {};
      }
    }
  },

  data: function data() {
    return {
      normFields: [],
      selected: 0
    };
  },


  watch: {
    fields: {
      handler: function handler(fields) {
        var normFields = [];
        if (fields instanceof Array) {
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = fields[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var f = _step.value;

              normFields.push(this.fieldDefinition(f));
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        } else {
          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = undefined;

          try {
            for (var _iterator2 = Object.keys(fields)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var i = _step2.value;

              normFields.push(this.fieldDefinition(fields[i], i));
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }
        }
        this.normFields = normFields;
      },

      immediate: true
    }
  },

  computed: {
    current: function current() {
      if (!this.normFields[this.selected]) {
        if (!this.normFields.length) {
          return {};
        }
        this.selected = this.normFields[0];
      }
      return this.normFields[this.selected];
    },
    isSelect: function isSelect() {
      return typeof this.current.values !== 'undefined';
    }
  },

  methods: {
    fieldDefinition: function fieldDefinition(field, name) {
      if ((typeof field === 'undefined' ? 'undefined' : _typeof(field)) == 'object') {
        field = Object.assign({}, field);
      } else {
        field = {
          label: field
        };
      }
      field.name = name || field.label;
      if (!field.label) {
        field.label = name;
      }
      return field;
    },
    set: function set(value) {
      if (value !== null) {
        if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) == 'object') {
          value = value.target.value;
        }
        var filter = Object.assign({}, this.current);
        filter.value = value;
        this.$emit('filter', filter);
      }
      if (this.isSelect) {
        this.$refs.select.clear();
      } else {
        this.$refs.input.value = '';
      }
    }
  }
};

var FilterResults = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "filter-pf" }, [_c('div', { staticClass: "row toolbar-pf-results" }, [_c('div', { staticClass: "col-sm-12" }, [_c('h5', [_vm._v(_vm._s(_vm.count) + " Results")]), _vm._v(" "), _vm.filters.length > 0 ? _c('p', [_vm._v("Active filters:")]) : _vm._e(), _vm._v(" "), _c('ul', { staticClass: "list-inline" }, _vm._l(_vm.filters, function (filter, i) {
      return _c('li', [_c('span', { staticClass: "active-filter label label-info" }, [_vm._v("\n            " + _vm._s(filter.label) + ": " + _vm._s(filter.value) + "\n            "), _c('a', [_c('span', { staticClass: "pficon pficon-close", on: { "click": function click($event) {
            _vm.$parent.clearFilter(i);
          } } })])])]);
    })), _vm._v(" "), _c('p', [_vm.filters.length > 0 ? _c('a', { staticClass: "clear-filters", on: { "click": function click($event) {
          _vm.$parent.clearAllFilters();
        } } }, [_vm._v("Clear All Filters")]) : _vm._e()])])])]);
  },
  staticRenderFns: [],
  name: 'pf-filter-results',

  props: {
    count: Number,
    filters: {
      type: Array,
      default: function _default() {
        return [];
      }
    }
  }
};

var PfNotification = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "alert", class: [_vm.alertClass, {
        'alert-dismissable': !_vm.persistent,
        'toast-pf': _vm.toast
      }] }, [_vm.showDropdown ? _c('bs-dropdown', [_vm._t("dropdown", _vm._l(_vm.actions, function (action) {
      return _c('li', { class: {
          divider: _vm.isSeparator(action),
          disabled: action.disabled === true
        }, attrs: { "role": _vm.isSeparator(action) ? 'separator' : 'menuitem' } }, [_vm.isSeparator(action) ? _c('a', { staticClass: "secondary-action", attrs: { "title": action.title }, on: { "click": function click($event) {
            _vm.triggered(action);
          } } }, [_vm._v("\n          " + _vm._s(action.name) + "\n        ")]) : _vm._e()]);
    }), { actions: _vm.actions })], 2) : _vm._e(), _vm._v(" "), _c('button', { directives: [{ name: "show", rawName: "v-show", value: !_vm.persistent && !_vm.toast, expression: "!persistent && !toast" }], staticClass: "close", attrs: { "type": "button", "data-dismiss": "alert", "aria-hidden": "true" }, on: { "click": _vm.dismiss } }, [_c('span', { staticClass: "pficon pficon-close" })]), _vm._v(" "), _vm.action && _vm.action.name ? _c('button', { staticClass: "pull-right btn", class: [_vm.buttonClass], attrs: { "type": "button", "title": _vm.action.title }, on: { "click": function click($event) {
          _vm.triggered(_vm.action);
        } } }, [_vm._v("\n    " + _vm._s(_vm.action.name) + "\n  ")]) : _vm._e(), _vm._v(" "), _c('span', { staticClass: "pficon", class: [_vm.typeIcon] }), _vm._v(" "), _vm._t("default")], 2);
  },
  staticRenderFns: [],
  name: 'pf-toast-notification',

  components: {
    BsDropdown: VueStrap.dropdown
  },

  props: {
    action: Object,
    actions: Array,
    delay: {
      type: Number,
      default: 8000
    },
    type: {
      type: String,
      default: 'info'
    },
    toast: {
      type: Boolean,
      default: false
    },
    persistent: {
      type: Boolean,
      default: false
    }
  },

  computed: {
    showDropdown: function showDropdown() {
      return this.toast && this.actions && this.actions.length;
    },
    alertClass: function alertClass() {
      return 'alert-' + (this.type || 'info');
    },
    buttonClass: function buttonClass() {
      if (!this.action || !this.action.button) {
        return 'btn-link';
      }
      return 'btn-' + this.action.button;
    },
    typeIcon: function typeIcon() {
      switch (this.type) {
        case 'success':
          return 'pficon-ok';
        case 'danger':
          return 'pficon-error-circle-o';
        case 'warning':
          return 'pficon-warning-triangle-o';
        default:
          return 'pficon-info';
      }
    }
  },

  watch: {
    toast: {
      handler: function handler() {
        this.updateTimeout();
      },

      immediate: true
    },
    delay: function delay() {
      this.updateTimeout();
    },
    persistent: function persistent() {
      this.updateTimeout();
    }
  },

  methods: {
    updateTimeout: function updateTimeout() {
      if (this._timeout) {
        clearTimeout(this._timeout);
      }
      if (this.toast && !this.persistent) {
        this._timeout = setTimeout(this.dismiss, this.delay);
      }
    },
    isSeparator: function isSeparator(action) {
      return action == '-' || action.separator;
    },
    dismiss: function dismiss() {
      this.$emit('dismiss', this);
      // workaround race conditions in event dispatching and handling in parent component
      if (this.toast && !this.persistent && this.$parent.notifications) {
        setTimeout(this.dismiss, 250);
      }
    },
    triggered: function triggered(action) {
      if (typeof action.handler == 'function') {
        action.handler(action);
      }
      this.$emit(action.emit || 'action', action);
    }
  }
};

var Notifications = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { directives: [{ name: "show", rawName: "v-show", value: _vm.$slots.default || _vm.notifications.length, expression: "$slots.default || notifications.length" }], class: { 'toast-notifications-list-pf': _vm.toast } }, [_vm._t("default"), _vm._v(" "), _vm._l(_vm.notifications, function (n, i) {
      return _c('pf-notification', { ref: "notification", refInFor: true, attrs: { "persistent": n.persistent, "type": n.type, "toast": _vm.toast }, on: { "dismiss": function dismiss($event) {
            _vm.dismiss(i);
          } } }, [_c('div', { domProps: { "innerHTML": _vm._s(n.message) } })]);
    })], 2);
  },
  staticRenderFns: [],
  name: 'pf-notifications',

  components: {
    PfNotification: PfNotification
  },

  props: {
    toast: {
      type: Boolean,
      default: false
    }
  },

  data: function data() {
    return {
      notifications: []
    };
  },


  methods: {
    add: function add(notification) {
      var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'info';
      var persistent = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      if (typeof notification == 'string') {
        notification = {
          message: notification,
          type: type,
          persistent: persistent
        };
      }
      this.notifications.push(notification);
    },
    dismiss: function dismiss(i) {
      if ((typeof i === 'undefined' ? 'undefined' : _typeof(i)) == 'object') {
        var obj = i;
        i = this.notifications.indexOf(obj);
        if (i < 0) {
          return;
        }
      }
      this.notifications.splice(i, 1);
    }
  }
};

var Layout = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { class: {
        'pf-layout-flex': _vm.flex
      } }, [!_vm.disabled ? _c('nav', { staticClass: "navbar", class: {
        'navbar-pf': _vm.horizontal,
        'navbar-pf-vertical': !_vm.horizontal
      }, attrs: { "role": "navigation" } }, [_c('div', { staticClass: "navbar-header" }, [_vm.collapsable ? _c('button', { staticClass: "navbar-toggle", attrs: { "type": "button" }, on: { "click": function click($event) {
          _vm.collapsed = !_vm.collapsed;
        } } }, [_c('span', { staticClass: "sr-only" }, [_vm._v("Toggle navigation")]), _vm._v(" "), _c('span', { staticClass: "icon-bar" }), _vm._v(" "), _c('span', { staticClass: "icon-bar" }), _vm._v(" "), _c('span', { staticClass: "icon-bar" })]) : _vm._e(), _vm._v(" "), _vm._t("brand")], 2), _vm._v(" "), _c('div', { staticClass: "collapse navbar-collapse navbar-collapse-1" }, [_c('ul', { staticClass: "nav navbar-nav navbar-utility" }, [_vm._t("utility-menu")], 2), _vm._v(" "), _vm.horizontal ? _c('ul', { staticClass: "nav navbar-nav navbar-primary" }, [_vm._t("horizontal-menu")], 2) : _vm._e()])]) : _vm._e(), _vm._v(" "), !_vm.disabled && !_vm.horizontal ? _c('div', { staticClass: "nav-pf-vertical nav-pf-vertical-with-sub-menus", class: {
        collapsed: _vm.collapsed,
        'hidden-icons-pf': !_vm.icons
      } }, [_c('ul', { staticClass: "list-group" }, [_vm._t("vertical-menu")], 2)]) : _vm._e(), _vm._v(" "), _c('div', { class: {
        'container-flex': !_vm.disabled && _vm.flex,
        'container-fluid': !_vm.disabled && !_vm.nomargin,
        'collapsed-nav': !_vm.disabled && _vm.collapsed,
        'container-pf-nav-pf-vertical': !_vm.disabled && !_vm.horizontal,
        'hidden-icons-pf': !_vm.disabled && !_vm.icons
      } }, [_vm._t("default")], 2)]);
  },
  staticRenderFns: [],
  name: 'pf-layout',

  props: {
    icons: {
      type: Boolean,
      default: false
    },

    horizontal: {
      type: Boolean,
      default: false
    },

    flex: {
      type: Boolean,
      default: false
    },

    collapsable: {
      type: Boolean,
      default: true
    },

    disabled: {
      type: Boolean,
      default: false
    },

    nomargin: {
      type: Boolean,
      default: false
    }
  },

  data: function data() {
    return {
      collapsed: false
    };
  },


  methods: {
    updateHtmlClasses: function updateHtmlClasses() {
      var html = window.document.documentElement;
      html.classList.add('transitions');
      if (this.disabled) {
        html.classList.remove('layout-pf');
        html.classList.remove('layout-pf-fixed');
      } else {
        html.classList.add('layout-pf');
        if (this.horizontal) {
          html.classList.remove('layout-pf-fixed');
        } else {
          html.classList.add('layout-pf-fixed');
        }
      }
    }
  },

  watch: {
    horizontal: {
      handler: function handler() {
        this.updateHtmlClasses();
      },

      immediate: true
    },

    disabled: function disabled() {
      this.updateHtmlClasses();
    }
  }
};

var PfTableRow = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('tr', { class: {
        selected: _vm.selectable && _vm.selected
      }, attrs: { "role": "row" } }, [_vm.selectable ? _c('td', { staticClass: "table-view-pf-select" }, [_c('label', [_c('span', { staticClass: "sr-only" }, [_vm._v("Select row " + _vm._s(_vm.num))]), _vm._v(" "), _c('input', { directives: [{ name: "model", rawName: "v-model", value: _vm.selected, expression: "selected" }], attrs: { "type": "checkbox" }, domProps: { "checked": Array.isArray(_vm.selected) ? _vm._i(_vm.selected, null) > -1 : _vm.selected }, on: { "change": function change($event) {
          var $$a = _vm.selected,
              $$el = $event.target,
              $$c = $$el.checked ? true : false;if (Array.isArray($$a)) {
            var $$v = null,
                $$i = _vm._i($$a, $$v);if ($$c) {
              $$i < 0 && (_vm.selected = $$a.concat($$v));
            } else {
              $$i > -1 && (_vm.selected = $$a.slice(0, $$i).concat($$a.slice($$i + 1)));
            }
          } else {
            _vm.selected = $$c;
          }
        } } })])]) : _vm._e(), _vm._v(" "), _vm._t("default")], 2);
  },
  staticRenderFns: [],
  name: 'pf-table-row',

  props: {
    num: Number,
    selectable: Boolean
  },

  data: function data() {
    return {
      selected: false
    };
  },


  watch: {
    selected: function selected() {
      this.$emit('select', this.selected);
    }
  }
};

var Table = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('table', { staticClass: "table dataTable", class: {
        'table-striped': _vm.striped,
        'table-bordered': _vm.bordered,
        'table-hover': _vm.hover
      }, attrs: { "role": "grid" } }, [_c('thead', [_c('tr', { attrs: { "row": "row" } }, [_vm.selectable ? _c('th', { staticClass: "table-view-pf-select", attrs: { "aria-label": "Select all rows" } }, [_c('label', [_c('span', { staticClass: "sr-only" }, [_vm._v("Select all rows")]), _vm._v(" "), _c('input', { ref: "checkSelectAll", attrs: { "type": "checkbox" }, on: { "change": _vm.changeSelectAll } })])]) : _vm._e(), _vm._v(" "), _vm._l(_vm.columns, function (column) {
      return _c('th', { class: {
          sorting: _vm.sortable && column != _vm.sortBy,
          sorting_asc: _vm.sortable && column == _vm.sortBy && _vm.sortDirection == 'asc',
          sorting_desc: _vm.sortable && column == _vm.sortBy && _vm.sortDirection == 'desc'
        }, on: { "click": function click($event) {
            _vm.setSortBy(column, column != _vm.sortBy || _vm.sortDirection == 'desc' ? 'asc' : 'desc');
          } } }, [_vm._v(_vm._s(column))]);
    })], 2)]), _vm._v(" "), _vm.pages > 1 ? _c('tfoot', [_c('tr', [_c('td', { staticClass: "table-summary", attrs: { "colspan": _vm.columns.length } }, [_c('span', { staticClass: "dataTables_paginate paginate-control", attrs: { "aria-label": "Search results pages" } }, [_c('ul', { staticClass: "pagination" }, [_c('li', { staticClass: "first", class: { disabled: _vm.page == 1 }, attrs: { "title": "First" }, on: { "click": function click($event) {
          _vm.setPage(1);
        } } }, [_c('span', { staticClass: "i fa fa-angle-double-left", attrs: { "aria-hidden": "true" } })]), _vm._v(" "), _c('li', { staticClass: "prev", class: { disabled: _vm.page <= 1 }, attrs: { "title": "Prev" }, on: { "click": function click($event) {
          _vm.setPage(_vm.page - 1);
        } } }, [_c('span', { staticClass: "i fa fa-angle-left", attrs: { "aria-hidden": "true" } })])]), _vm._v(" "), _c('div', { staticClass: "pagination-input" }, [_c('input', { directives: [{ name: "model", rawName: "v-model", value: _vm.page, expression: "page" }], staticClass: "paginate_input", style: {
        width: .7 * (_vm.pages.toString().length + 1) + 'em'
      }, attrs: { "type": "text" }, domProps: { "value": _vm._s(_vm.page) }, on: { "input": function input($event) {
          if ($event.target.composing) {
            return;
          }_vm.page = $event.target.value;
        } } }), _vm._v(" "), _c('span', { staticClass: "paginate_of" }, [_vm._v(" of "), _c('b', [_vm._v(_vm._s(_vm.pages))])])]), _vm._v(" "), _c('ul', { staticClass: "pagination" }, [_c('li', { staticClass: "next", class: { disabled: _vm.page >= _vm.pages }, attrs: { "title": "Next" }, on: { "click": function click($event) {
          _vm.setPage(_vm.page + 1);
        } } }, [_c('span', { staticClass: "i fa fa-angle-right", attrs: { "aria-hidden": "true" } })]), _vm._v(" "), _c('li', { staticClass: "last", class: { disabled: _vm.page == _vm.pages }, attrs: { "title": "Last" }, on: { "click": function click($event) {
          _vm.setPage(_vm.pages);
        } } }, [_c('span', { staticClass: "i fa fa-angle-double-right", attrs: { "aria-hidden": "true" } })])])])])])]) : _vm._e(), _vm._v(" "), _c('tbody', _vm._l(_vm.rows, function (row, i) {
      return _c('pf-table-row', { ref: "row", refInFor: true, attrs: { "num": i, "selectable": _vm.selectable } }, [_vm._t("default", null, { row: row })], 2);
    }))], 1);
  },
  staticRenderFns: [],
  name: 'pf-table',

  components: {
    PfTableRow: PfTableRow
  },

  props: {
    page: Number,
    pages: {
      type: Number,
      default: 0
    },
    columns: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    rows: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    striped: Boolean,
    bordered: Boolean,
    hover: Boolean,
    selectable: Boolean,
    sortable: Boolean,
    sortBy: String,
    sortDirection: String
  },

  methods: {
    setPage: function setPage(page) {
      page = Math.max(Math.min(page, this.pages), 1);
      this.$emit('change-page', page);
    },
    setSortBy: function setSortBy(field, direction) {
      this.$emit('sort-by', field, direction);
    },
    changeSelectAll: function changeSelectAll() {
      this.setAllSelected(this.$refs.checkSelectAll.checked);
    },
    setAllSelected: function setAllSelected() {
      var selected = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.$refs.row[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var row = _step.value;

          row.selected = selected;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    },
    getSelected: function getSelected() {
      var selected = [];
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = this.$refs.row[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var row = _step2.value;

          var id = row.num;
          if (typeof id != 'undefined' && row.selected && this.rows[id]) {
            selected.push(this.rows[id]);
          }
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return selected;
    }
  }
};

var Tooltip = require('tether-tooltip');

var positions = ['top-left', 'left-top', 'left-middle', 'left-bottom', 'bottom-left', 'bottom-center', 'bottom-right', 'right-bottom', 'right-middle', 'right-top', 'top-right', 'top-center'];

function createTooltip(el, value, modifiers) {
  var position = 'top-center';
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = positions[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var pos = _step.value;

      if (modifiers[pos]) {
        position = pos;
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  var classes = /^((?:(?:top|bottom))?(?:^|-)?(?:left|right)?)(?:-|$)/.exec(position);
  classes = classes ? classes[1] : '';

  position = position.replace('-', ' ');

  el._tooltip = new Tooltip({
    target: el,
    position: position,
    content: value,
    classes: classes
  });

  var arrow = document.createElement('DIV');
  arrow.className = 'tooltip-arrow';

  el._tooltip.drop.drop.insertBefore(arrow, el._tooltip.drop.content);
  el._tooltip.drop.content.className = 'tooltip-inner';
}

function destroyTooltip(el) {
  if (el._tooltip) {
    el._tooltip.destroy();
    Reflect.deleteProperty(el, '_tooltip');
  }
}

var Tooltip$1 = {
  name: 'tooltip',
  bind: function bind(el, _ref) {
    var value = _ref.value,
        modifiers = _ref.modifiers;

    destroyTooltip(el);
    if (value) {
      createTooltip(el, value, modifiers);
    }
  },
  update: function update(el, _ref2) {
    var value = _ref2.value,
        modifiers = _ref2.modifiers;

    if (!value) {
      destroyTooltip();
    } else if (el._tooltip) {
      el._tooltip.drop.content.innerHTML = value;
    } else {
      createTooltip(el, value, modifiers);
    }
  },
  unbind: function unbind(el) {
    destroyTooltip(el);
  }
};

var VuePatternfly = {
  AggregateStatusCard: AggregateStatusCard,
  C3Chart: C3Chart,
  Card: Card,
  CardNotification: CardNotification,
  EmptyChart: EmptyChart,
  Sort: PfSort,
  ColumnPicker: PfColumnPicker,
  Toolbar: Toolbar,
  UtilizationBarChart: UtilizationBarChart,
  FilterFields: FilterFields,
  FilterResults: FilterResults,
  Notifications: Notifications,
  Notification: PfNotification,
  Tooltip: Tooltip$1,
  Layout: Layout,
  Table: Table
};

VuePatternfly.install = function (Vue) {
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = Object.keys(VuePatternfly)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var name = _step.value;

      var component = VuePatternfly[name];
      if (component.bind) {
        Vue.directive(component.name || name, component);
      } else {
        Vue.component(component.name || name, component);
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  VueStrap.install(Vue);
};

if (typeof window !== 'undefined' && window.Vue) {
  window.Vue.use(VuePatternfly);
}

exports['default'] = VuePatternfly;

Object.defineProperty(exports, '__esModule', { value: true });

})));
